SystemOrganization addCategory: #'EtoysPlugins-Kedama'!
SystemOrganization addCategory: #'EtoysPlugins-Scratch'!
SystemOrganization addCategory: #'EtoysPlugins-VideoForSqueak'!

ProtoObject subclass: #KedamaPlugin2
	instanceVariableNames: 'kedamaRandomSeed randA randM randQ randR'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EtoysPlugins-Kedama'!

!KedamaPlugin2 class methodsFor: 'as yet unclassified' stamp: 'yo 10/13/2005 01:29'!
declareCVarsIn: cg

	cg var: #kedamaRandomSeed type: 'unsigned int'.
	cg var: #randA type: 'unsigned int'.
	cg var: #randM type: 'unsigned int'.
	cg var: #randQ type: 'unsigned int'.
	cg var: #randR type: 'unsigned int'.
! !

!KedamaPlugin2 class methodsFor: 'accessing method dictionary' stamp: 'tfel 8/3/2016 09:37'!
isUniClass

	^ self ~~ KedamaPlugin2! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
degreesFromX: x y: y

	| tanVal theta |
	self inline: true.
	self returnTypeC: 'double'.
	self var: 'x' declareC: 'double x'.
	self var: 'y' declareC: 'double y'.
	self var: 'tanVal' declareC: 'double tanVal'.
	self var: 'theta' declareC: 'double theta'.

	x = 0.0 ifTrue: [
		y >= 0.0 ifTrue: [^ 90.0] ifFalse: [^ 270.0].
	] ifFalse: [
		tanVal _ y / x.
		theta _ self cCode: 'atan(tanVal)' inSmalltalk: [tanVal arcTan].
		x >= 0.0 ifTrue: [
			y >= 0.0
				ifTrue: [^ theta / 0.0174532925199433]
				ifFalse: [^ 360.0 + (theta / 0.0174532925199433)]
		] ifFalse: [
			^ 180.0 + (theta / 0.0174532925199433)
		]
	].
	^ 0.0.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
degreesToRadians: degrees

	| headingRadians deg q |
	self inline: true.
	self returnTypeC: 'double'.
	self var: 'degrees' declareC: 'double degrees'.
	self var: 'deg' declareC: 'double deg'.
	self var: 'headingRadians' declareC: 'double headingRadians'.
	self var: 'q' declareC: 'int q'.

	deg _ 90.0 - degrees.
	q _ deg / 360.0.
	deg < 0.0 ifTrue: [q _ q - 1].
	headingRadians _ (deg - (q * 360.0)) * 0.0174532925199433.
	^ headingRadians.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
drawTurtlesInArray

	| visibleArray colorArray yArray xArray destHeight destWidth destBits size x y visible visibleOop colorOop yOop xOop destOop bitsIndex |
	self export: true.
	self inline: true.
	self var: 'destBits' declareC: 'unsigned int *destBits'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'colorArray' declareC: 'unsigned int *colorArray'.
	self var: 'visibleArray' declareC: 'unsigned char *visibleArray'.

	visibleOop _ interpreterProxy stackValue: 0.
	colorOop _ interpreterProxy stackValue: 1.
	yOop _ interpreterProxy stackValue: 2.
	xOop _ interpreterProxy stackValue: 3.
	destHeight _ interpreterProxy stackIntegerValue: 4.
	destWidth _ interpreterProxy stackIntegerValue: 5.
	destOop _ interpreterProxy stackValue: 6.

	interpreterProxy failed ifTrue: [^ nil].


	(interpreterProxy isWords: destOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: colorOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isBytes: visibleOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	(destHeight * destWidth) ~= (interpreterProxy slotSizeOf: destOop) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: xOop.
	(interpreterProxy slotSizeOf: yOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: colorOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: visibleOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	xArray _ interpreterProxy firstIndexableField: xOop.
	yArray _ interpreterProxy firstIndexableField: yOop.
	colorArray _ interpreterProxy firstIndexableField: colorOop.
	visibleArray _ interpreterProxy firstIndexableField: visibleOop.
	destBits _ interpreterProxy firstIndexableField: destOop.

	0 to: size - 1 do: [:i |
		x _ self cCoerce: (xArray at: i) to: 'int'.
		self cCode: '' inSmalltalk: [x _ x asInteger].
		y _ self cCoerce: (yArray at: i) to: 'int'.
		self cCode: '' inSmalltalk: [y _ y asInteger].
		visible _ (visibleArray at: i).
		((visible ~= 0) and: [((x >= 0) and: [y >= 0]) and: [(x < destWidth) and: [y < destHeight]]]) ifTrue: [
			bitsIndex _ ((y * destWidth) + x).
			destBits at: bitsIndex put: (colorArray at: i).
		]
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 7.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
getHeadingArrayInto

	| resultOop headingOop size headingArray resultArray heading |
	self export: true.
	self inline: true.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'resultArray' declareC: 'float *resultArray'.
	self var: 'heading' declareC: 'double heading'.

	resultOop _ interpreterProxy stackValue: 0.
	headingOop _ interpreterProxy stackValue: 1.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: resultOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: headingOop.
	(interpreterProxy slotSizeOf: resultOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	headingArray _ interpreterProxy firstIndexableField: headingOop.
	resultArray _ interpreterProxy firstIndexableField: resultOop.

	0 to: size - 1 do: [:i |
		heading _ headingArray at: i.
		heading _ heading / 0.0174532925199433.
		heading _ 90.0 - heading.
		heading > 0.0 ifFalse: [heading _ heading + 360.0].
		resultArray at: i put: heading.
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 2.

	! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
getScalarHeading

	| headingOop headingArray heading index |
	self export: true.
	self inline: true.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'heading' declareC: 'double heading'.

	headingOop _ interpreterProxy stackValue: 0.
	index _ interpreterProxy stackIntegerValue: 1.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	(interpreterProxy slotSizeOf: headingOop) < index ifTrue: [interpreterProxy primitiveFail. ^ nil].

	headingArray _ interpreterProxy firstIndexableField: headingOop.

	heading _ headingArray at: index - 1.
	heading _ self radiansToDegrees: heading.

	interpreterProxy failed ifTrue: [^ nil].

	interpreterProxy pop: 3.
	interpreterProxy pushFloat: heading.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
initialiseModule

	self export: true.
	kedamaRandomSeed _ 17.

	randA := 16r000041A7.    " magic constant =      16807 "
	randM := 16r7FFFFFFF.    " magic constant = 2147483647 "
	randQ := randM // randA.
	randR  := randM \\ randA.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
kedamaRandom2: range

	| lo hi r v val |
	self inline: true.
	range < 0 ifTrue: [r _ 0 - range] ifFalse: [r _ range].
	hi _ kedamaRandomSeed // randQ.
	lo _ kedamaRandomSeed \\ randQ. 
	kedamaRandomSeed _ (randA * lo) - (randR * hi).
	v _ kedamaRandomSeed bitAnd: 65535.
	val _ (v * (r + 1)) >> 16.
	range < 0 ifTrue: [^ 0 - val] ifFalse: [^ val].
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
kedamaRandom: range

	| r val |
	self inline: true.
	range < 0 ifTrue: [r _ 0 - range] ifFalse: [r _ range].
	kedamaRandomSeed _ ((kedamaRandomSeed * 1309) + 13849) bitAnd: 65535.
	val _ (kedamaRandomSeed * (r + 1)) >> 16.
	range < 0 ifTrue: [^ 0 - val] ifFalse: [^ val].
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
kedamaSetRandomSeed

	| seed |
	self inline: true.
	self export: true.
	seed _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ nil].

	kedamaRandomSeed _ seed bitAnd: 65536.

	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
makeMask

	| shiftAmount pixel maskBits dataBits dataSize maskSize dOrigin mOrigin data alpha highMask |

	self export: true.
	self inline: true.
	self var: 'dOrigin' declareC: 'unsigned int* dOrigin'.
	self var: 'mOrigin' declareC: 'unsigned int* mOrigin'.
	self var: 'highMask' declareC: 'unsigned int highMask'.
	self var: 'alpha' declareC: 'unsigned int alpha'.
	self var: 'pixel' declareC: 'unsigned int pixel'.

	shiftAmount _ interpreterProxy stackIntegerValue: 0.
	pixel _ interpreterProxy stackIntegerValue: 1.
	maskBits _ interpreterProxy stackValue: 2.
	dataBits _ interpreterProxy stackValue: 3.

	interpreterProxy failed ifTrue: [^ nil].

	dataSize _ interpreterProxy slotSizeOf: dataBits.
	maskSize _ interpreterProxy slotSizeOf: maskBits.

	dataSize = maskSize ifFalse: [interpreterProxy primitiveFail. ^ nil].
	shiftAmount < -32 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	shiftAmount > 8 ifTrue: [interpreterProxy primitiveFail. ^ nil].

	dOrigin _ interpreterProxy firstIndexableField: dataBits.
	mOrigin _ interpreterProxy firstIndexableField: maskBits.

	highMask _ 16rFF000000.
	0 to: dataSize -1 do: [:i |
		data _ dOrigin at: i.
		alpha _ data bitShift: shiftAmount.
		(alpha > 255) ifTrue: [alpha _ 255].
		(alpha < 0) ifTrue: [alpha _ 0].
		mOrigin at: i put: (((alpha << 24) bitAnd: highMask) bitOr: pixel).
	].

	interpreterProxy pop: 4.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
makeMaskLog

	| max pixel maskBits dataBits dataSize maskSize dOrigin mOrigin data alpha highMask maxLog maxOop maxFirst |

	self export: true.
	self inline: true.
	self var: 'dOrigin' declareC: 'unsigned int* dOrigin'.
	self var: 'mOrigin' declareC: 'unsigned int* mOrigin'.
	self var: 'highMask' declareC: 'unsigned int highMask'.
	self var: 'maxFirst' declareC: 'unsigned int* maxFirst'.
	self var: 'max' declareC: 'unsigned int max'.
	self var: 'alpha' declareC: 'unsigned int alpha'.
	self var: 'pixel' declareC: 'unsigned int pixel'.
	self var: 'maxLog' declareC: 'double maxLog'.

	maxOop _ interpreterProxy stackValue: 0.
	pixel _ interpreterProxy stackIntegerValue: 1.
	maskBits _ interpreterProxy stackValue: 2.
	dataBits _ interpreterProxy stackValue: 3.

	interpreterProxy failed ifTrue: [^ nil].

	maxFirst _ (interpreterProxy firstIndexableField: maxOop).
	max _ maxFirst at: 0.

	interpreterProxy failed ifTrue: [^ nil].

	maxLog _ self cCode: 'log(max)' inSmalltalk: [max ln].

	dataSize _ interpreterProxy slotSizeOf: dataBits.
	maskSize _ interpreterProxy slotSizeOf: maskBits.

	dataSize = maskSize ifFalse: [interpreterProxy primitiveFail. ^ nil].

	dOrigin _ interpreterProxy firstIndexableField: dataBits.
	mOrigin _ interpreterProxy firstIndexableField: maskBits.

	highMask _ 16rFF000000.
	0 to: dataSize -1 do: [:i |
		data _ dOrigin at: i.
		data = 0 ifTrue: [alpha _ 0] ifFalse: [
			alpha _ ((255.0 / maxLog) * (self cCode: 'log(data)' inSmalltalk: [data ln])) asInteger.
		].
		(alpha > 255) ifTrue: [alpha _ 255].
		mOrigin at: i put: (((alpha << 24) bitAnd: highMask) bitOr: pixel).
	].

	interpreterProxy pop: 4.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
makeTurtlesMap

	| height width yOop xOop whoOop mapOop size xArray yArray whoArray map x y mapIndex |
	self export: true.
	self inline: true.

	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'whoArray' declareC: 'unsigned int *whoArray'.
	self var: 'map' declareC: 'unsigned int *map'.

	height _ interpreterProxy stackIntegerValue: 0.
	width _ interpreterProxy stackIntegerValue: 1.
	yOop _ interpreterProxy stackValue: 2.
	xOop _ interpreterProxy stackValue: 3.
	whoOop _ interpreterProxy stackValue: 4.
	mapOop _ interpreterProxy stackValue: 5.

	(interpreterProxy isWords: yOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: whoOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: mapOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: whoOop.
	(interpreterProxy slotSizeOf: xOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: yOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: mapOop) ~= (height * width) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	xArray _ interpreterProxy firstIndexableField: xOop.
	yArray _ interpreterProxy firstIndexableField: yOop.
	whoArray _ interpreterProxy firstIndexableField: whoOop.
	map _ interpreterProxy firstIndexableField: mapOop.
	
	0 to: (height * width) - 1 do: [:index |
		map at: index put: 0.
	].

	0 to: size - 1 do: [:index |
		x _ xArray at: index.
		y _ yArray at: index.
		mapIndex _ (width * y) + x.
		(mapIndex >= 0  and: [mapIndex < (height * width)]) ifTrue: [
			map at: mapIndex put: (whoArray at: index).
		].
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 6.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveAddArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg wordsResult floatsArg floatsResult floatsRcvr |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgWords & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) + (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) + (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) + (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) + (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveAddScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr wordsResult floatsResult floatsRcvr isArgInt intArg floatArg |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgInt & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) + intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) + floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) + intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) + floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 1/19/2006 20:20'!
primitiveAndByteArray

	| length rcvrOop otherOop otherArray rcvrArray length1 length2 |

	self export: true.
	self inline: true.
	self var: #rcvrArray declareC: 'unsigned char *rcvrArray'.
	self var: #otherArray declareC: 'unsigned char *otherArray'.

	otherOop _ interpreterProxy stackObjectValue: 0.
	rcvrOop _ interpreterProxy stackValue: 1.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isBytes: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: otherOop).
	interpreterProxy failed ifTrue:[^nil].
	length1 _ interpreterProxy stSizeOf: rcvrOop.
	length2 _ interpreterProxy stSizeOf: otherOop.
	interpreterProxy failed ifTrue:[^nil].
	length _ length1.
	length1 > length2 ifTrue: [
		length _ length2.
	].

	otherArray _ interpreterProxy firstIndexableField: otherOop.
	rcvrArray _ interpreterProxy firstIndexableField: rcvrOop.
	0 to: length-1 do:[:i|
		rcvrArray at: i put: (((rcvrArray at: i) + (otherArray at: i)) = 2).
	].
	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveDivArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg wordsResult floatsArg floatsResult floatsRcvr |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgWords & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) / (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) / (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) / (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) / (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveDivScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr wordsResult floatsResult floatsRcvr isArgInt intArg floatArg |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgInt & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) // intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) / floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) / intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) / floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 20:58'!
primitiveEQArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg floatsArg floatsRcvr bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) = (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) = (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) = (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) = (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 20:58'!
primitiveEQScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr floatsRcvr isArgInt intArg floatArg bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) = intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) = floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) = intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) = floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 21:05'!
primitiveGEArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg floatsArg floatsRcvr bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) >= (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) >= (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) >= (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) >= (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 21:06'!
primitiveGEScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr floatsRcvr isArgInt intArg floatArg bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) >= intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) >= floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) >= intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) >= floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 21:05'!
primitiveGTArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg floatsArg floatsRcvr bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) > (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) > (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) > (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) > (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 21:04'!
primitiveGTScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr floatsRcvr isArgInt intArg floatArg bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) > intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) > floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) > intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) > floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 20:49'!
primitiveLEArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg floatsArg floatsRcvr bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) <= (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) <= (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) <= (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) <= (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 20:49'!
primitiveLEScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr floatsRcvr isArgInt intArg floatArg bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) <= intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) <= floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) <= intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) <= floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 20:42'!
primitiveLTArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg floatsArg floatsRcvr bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) < (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) < (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) < (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) < (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 20:41'!
primitiveLTScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr floatsRcvr isArgInt intArg floatArg bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) < intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) < floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) < intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) < floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveMulArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg wordsResult floatsArg floatsResult floatsRcvr |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgWords & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) * (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) * (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) * (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) * (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveMulScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr wordsResult floatsResult floatsRcvr isArgInt intArg floatArg |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgInt & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) * intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) * floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) * intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) * floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 21:11'!
primitiveNEArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg floatsArg floatsRcvr bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) ~= (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) ~= (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) ~= (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) ~= (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 21:11'!
primitiveNEScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr floatsRcvr isArgInt intArg floatArg bytesResult |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #bytesResult declareC: 'unsigned char *bytesResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) ~= intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (wordsRcvr at: i) ~= floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) ~= intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			bytesResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				bytesResult at: i put: (floatsRcvr at: i) ~= floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 17:49'!
primitiveNotByteArray

	| length rcvrOop rcvrArray |

	self export: true.
	self inline: true.
	self var: #rcvrArray declareC: 'unsigned char *rcvrArray'.

	rcvrOop _ interpreterProxy stackValue: 0.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isBytes: rcvrOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy failed ifTrue:[^nil].

	rcvrArray _ interpreterProxy firstIndexableField: rcvrOop.
	0 to: length-1 do:[:i|
		(rcvrArray at: i) = 0 ifTrue: [
			rcvrArray at: i put: 1
		] ifFalse: [
			rcvrArray at: i put: 0
		].
	].
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 1/19/2006 20:17'!
primitiveOrByteArray

	| length rcvrOop otherOop otherArray rcvrArray length1 length2 |

	self export: true.
	self inline: true.
	self var: #rcvrArray declareC: 'unsigned char *rcvrArray'.
	self var: #otherArray declareC: 'unsigned char *otherArray'.

	otherOop _ interpreterProxy stackObjectValue: 0.
	rcvrOop _ interpreterProxy stackValue: 1.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isBytes: rcvrOop).
	interpreterProxy success: (interpreterProxy isBytes: otherOop).
	interpreterProxy failed ifTrue:[^nil].
	length1 _ interpreterProxy stSizeOf: rcvrOop.
	length2 _ interpreterProxy stSizeOf: otherOop.
	interpreterProxy failed ifTrue:[^nil].
	length _ length1.
	length1 > length2 ifTrue: [
		length _ length2.
	].

	otherArray _ interpreterProxy firstIndexableField: otherOop.
	rcvrArray _ interpreterProxy firstIndexableField: rcvrOop.
	0 to: length-1 do:[:i|
		rcvrArray at: i put: (((rcvrArray at: i) + (otherArray at: i)) > 0).
	].
	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'predicated array primitive' stamp: 'yo 1/19/2006 16:16'!
primitivePredicateAtAllPutBoolean

	| rcvrOop valOop val valuesOop values predicatesOop predicates |

	self export: true.
	self inline: true.
	self var: #values declareC: 'unsigned char *values'.
	self var: #predicates declareC: 'unsigned char *predicates'.

	valOop _ interpreterProxy stackValue: 0.
	rcvrOop _ interpreterProxy stackObjectValue: 1.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isIntegerValue: valOop) ifTrue: [
		val _ interpreterProxy integerValueOf: valOop.
	] ifFalse: [
		val _ interpreterProxy booleanValueOf: valOop.
	].

	valuesOop _ interpreterProxy fetchPointer: 1 ofObject: rcvrOop.
	predicatesOop _ interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isBytes: predicatesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isBytes: valuesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	values _ interpreterProxy firstIndexableField: valuesOop.
	predicates _ interpreterProxy firstIndexableField: predicatesOop.
	
	0 to: (interpreterProxy stSizeOf: valuesOop) - 1 do:[:i |
		(predicates at: i) = 1 ifTrue: [
			values at: i put: val
		].
	].

	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'predicated array primitive' stamp: 'yo 10/13/2005 23:35'!
primitivePredicateAtAllPutColor

	| rcvrOop val valuesOop values predicatesOop predicates |

	self export: true.
	self inline: true.
	self var: #values declareC: 'unsigned int *values'.
	self var: #val declareC: 'unsigned int val'.
	self var: #predicates declareC: 'unsigned char *predicates'.

	val _ interpreterProxy stackIntegerValue: 0.
	rcvrOop _ interpreterProxy stackObjectValue: 1.
	interpreterProxy failed ifTrue: [^ nil].

	val _ val bitOr: 16rFF000000.

	valuesOop _ interpreterProxy fetchPointer: 1 ofObject: rcvrOop.
	predicatesOop _ interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isBytes: predicatesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: valuesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	values _ interpreterProxy firstIndexableField: valuesOop.
	predicates _ interpreterProxy firstIndexableField: predicatesOop.
	
	0 to: (interpreterProxy stSizeOf: valuesOop) - 1 do:[:i |
		(predicates at: i) = 1 ifTrue: [
			values at: i put: val
		].
	].

	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'predicated array primitive' stamp: 'yo 10/13/2005 23:36'!
primitivePredicateAtAllPutNumber

	| rcvrOop val valuesOop values predicatesOop predicates |

	self export: true.
	self inline: true.
	self var: #values declareC: 'float *values'.
	self var: #val declareC: 'float val'.
	self var: #predicates declareC: 'unsigned char *predicates'.

	val _ interpreterProxy stackFloatValue: 0.
	rcvrOop _ interpreterProxy stackObjectValue: 1.
	interpreterProxy failed ifTrue: [^ nil].

	valuesOop _ interpreterProxy fetchPointer: 1 ofObject: rcvrOop.
	predicatesOop _ interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isBytes: predicatesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: valuesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	values _ interpreterProxy firstIndexableField: valuesOop.
	predicates _ interpreterProxy firstIndexableField: predicatesOop.
	
	0 to: (interpreterProxy stSizeOf: valuesOop) - 1 do:[:i |
		(predicates at: i) = 1 ifTrue: [
			values at: i put: val
		].
	].

	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'predicated array primitive' stamp: 'yo 10/13/2005 23:33'!
primitivePredicateAtAllPutObject

	| rcvrOop valOop valuesOop values predicatesOop predicates |

	self export: true.
	self inline: true.
	self var: #values declareC: 'int *values'.
	self var: #predicates declareC: 'unsigned char *predicates'.

	valOop _ interpreterProxy stackValue: 0.
	rcvrOop _ interpreterProxy stackObjectValue: 1.
	interpreterProxy failed ifTrue: [^ nil].

	valuesOop _ interpreterProxy fetchPointer: 1 ofObject: rcvrOop.
	predicatesOop _ interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isBytes: predicatesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isPointers: valuesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	values _ interpreterProxy firstIndexableField: valuesOop.
	predicates _ interpreterProxy firstIndexableField: predicatesOop.
	
	0 to: (interpreterProxy stSizeOf: valuesOop) - 1 do:[:i |
		(predicates at: i) = 1 ifTrue: [
			values at: i put: valOop
		].
	].

	interpreterProxy pop: 1.
! !

!KedamaPlugin2 methodsFor: 'predicated array primitive' stamp: 'yo 10/14/2005 00:02'!
primitivePredicateReplaceBytes

	| rcvrOop valuesOop values predicatesOop predicates repStart repOop stop start replacement valuesSize predicatesSize replacementSize |

	self export: true.
	self inline: true.
	self var: #values declareC: 'unsigned char *values'.
	self var: #predicates declareC: 'unsigned char *predicates'.
	self var: #replacement declareC: 'unsigned char *replacement'.

	repStart _ interpreterProxy stackIntegerValue: 0.
	repOop _ interpreterProxy stackObjectValue: 1.
	stop _ interpreterProxy stackIntegerValue: 2.
	start _ interpreterProxy stackIntegerValue: 3.
	rcvrOop _ interpreterProxy stackObjectValue: 4.
	interpreterProxy failed ifTrue: [^ nil].

	valuesOop _ interpreterProxy fetchPointer: 1 ofObject: rcvrOop.
	predicatesOop _ interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isBytes: predicatesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	((interpreterProxy isBytes: valuesOop) and: [interpreterProxy isBytes: repOop])
		ifFalse: [interpreterProxy primitiveFail. ^ nil].

	values _ interpreterProxy firstIndexableField: valuesOop.
	predicates _ interpreterProxy firstIndexableField: predicatesOop.
	replacement _ interpreterProxy firstIndexableField: repOop.
	valuesSize _ interpreterProxy stSizeOf: valuesOop.
	predicatesSize _ interpreterProxy stSizeOf: predicatesOop.
	replacementSize _ interpreterProxy stSizeOf: repOop.

	start > stop ifTrue: [interpreterProxy primitiveFail. ^ nil].
	start < 1 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	start > valuesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	start > predicatesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	stop > valuesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	stop > predicatesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	repStart < 1 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	repStart > replacementSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(replacementSize - repStart + 1) < (stop - start + 1) ifTrue: [interpreterProxy primitiveFail. ^ nil].
	
	start - 1 to: stop - 1 do: [:i |
		(predicates at: i) = 1 ifTrue: [
			values at: i put: (replacement at: repStart + i - start).
		].
	].

	interpreterProxy pop: 4.
! !

!KedamaPlugin2 methodsFor: 'predicated array primitive' stamp: 'yo 1/20/2006 12:01'!
primitivePredicateReplaceWords

	| rcvrOop valuesOop values predicatesOop predicates repStart repOop stop start replacement valuesSize predicatesSize replacementSize vIsFloat rIsFloat floatValues floatReplacement fv |

	self export: true.
	self inline: true.
	self var: #values declareC: 'unsigned int *values'.
	self var: #floatValues declareC: 'float *floatValues'.
	self var: #predicates declareC: 'unsigned char *predicates'.
	self var: #replacement declareC: 'unsigned int *replacement'.
	self var: #floatReplacement declareC: 'float *floatReplacement'.
	self var: #fv declareC: 'unsigned int fv'.

	repStart _ interpreterProxy stackIntegerValue: 0.
	repOop _ interpreterProxy stackObjectValue: 1.
	stop _ interpreterProxy stackIntegerValue: 2.
	start _ interpreterProxy stackIntegerValue: 3.
	rcvrOop _ interpreterProxy stackObjectValue: 4.
	interpreterProxy failed ifTrue: [^ nil].

	valuesOop _ interpreterProxy fetchPointer: 1 ofObject: rcvrOop.
	predicatesOop _ interpreterProxy fetchPointer: 0 ofObject: rcvrOop.
	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isBytes: predicatesOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(((interpreterProxy isWords: valuesOop) and: [interpreterProxy isWords: repOop]) or: [
		(interpreterProxy isPointers: valuesOop) and: [interpreterProxy isPointers: repOop]]) 
			ifFalse: [interpreterProxy primitiveFail. ^ nil].

	predicates _ interpreterProxy firstIndexableField: predicatesOop.
	valuesSize _ interpreterProxy stSizeOf: valuesOop.
	predicatesSize _ interpreterProxy stSizeOf: predicatesOop.
	replacementSize _ interpreterProxy stSizeOf: repOop.

	start > stop ifTrue: [interpreterProxy primitiveFail. ^ nil].
	start < 1 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	start > valuesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	start > predicatesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	stop > valuesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	stop > predicatesSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	repStart < 1 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	repStart > replacementSize ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(replacementSize - repStart + 1) < (stop - start + 1) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	vIsFloat _ interpreterProxy is: valuesOop MemberOf: 'KedamaFloatArray'.
	rIsFloat _ interpreterProxy is: repOop MemberOf: 'KedamaFloatArray'.
	(vIsFloat and: [rIsFloat]) ifTrue: [
		floatValues _ interpreterProxy firstIndexableField: valuesOop.
		floatReplacement _  interpreterProxy firstIndexableField: repOop.
		start - 1 to: stop - 1 do: [:i |
			(predicates at: i) = 1 ifTrue: [
				floatValues at: i put: (floatReplacement at: repStart + i - start).
			].
		].
	].
	(vIsFloat and: [rIsFloat not]) ifTrue: [
		floatValues _ interpreterProxy firstIndexableField: valuesOop.
		replacement _  interpreterProxy firstIndexableField: repOop.
		start - 1 to: stop - 1 do: [:i |
			(predicates at: i) = 1 ifTrue: [
				floatValues at: i put: (replacement at: repStart + i - start).
			].
		].
	].
	(vIsFloat not and: [rIsFloat]) ifTrue: [
		values _ interpreterProxy firstIndexableField: valuesOop.
		floatReplacement _  interpreterProxy firstIndexableField: repOop.
		start - 1 to: stop - 1 do: [:i |
			(predicates at: i) = 1 ifTrue: [
				fv _ self cCoerce: (floatReplacement at: repStart + i - start) to: 'unsigned int'.
				self cCode: '' inSmalltalk: [fv _ fv asInteger].
				values at: i put: fv.
			].
		].
	].
	(vIsFloat not and: [rIsFloat not]) ifTrue: [
		values _ interpreterProxy firstIndexableField: valuesOop.
		replacement _  interpreterProxy firstIndexableField: repOop.
		start - 1 to: stop - 1 do: [:i |
			(predicates at: i) = 1 ifTrue: [
				values at: i put: (replacement at: repStart + i - start).
			].
		].
	].

	interpreterProxy pop: 4.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 1/21/2006 00:21'!
primitiveRemArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg wordsResult floatsArg floatsResult floatsRcvr wordRcvr wordArg wordResult floatArg floatResult floatRcvr |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.
	self var: #floatResult declareC: 'double floatResult'.
	self var: #wordResult declareC: 'unsigned int wordResult'.
	self var: #floatRcvr declareC: 'double floatRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #wordRcvr declareC: 'unsigned int wordRcvr'.
	self var: #wordArg declareC: 'unsigned int wordArg'.


	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgWords & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordRcvr _ (wordsRcvr at: i).
				wordArg _ (wordsArg at: i).
				wordResult _ wordRcvr \\ wordArg.
				"In this primitive, words are supposed to be unsigned."
				wordsResult at: i put: wordResult.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordRcvr _ wordsRcvr at: i.
				floatArg _ floatsArg at: i.
				floatResult _ wordRcvr / floatArg.
				floatResult _ self cCode: 'floor(floatResult)' inSmalltalk: [floatResult floor].
				floatsResult at: i put: wordRcvr - (floatResult * floatArg).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatRcvr _ floatsRcvr at: i.
				wordArg _ wordsArg at: i.
				floatResult _ floatRcvr / wordArg.
				floatResult _ self cCode: 'floor(floatResult)' inSmalltalk: [floatResult floor].
				floatsResult at: i put: (floatRcvr - (floatResult * wordArg)).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatRcvr _ floatsRcvr at: i.
				floatArg _ floatsArg at: i.
				floatResult _ floatRcvr / floatArg.
				floatResult _ self cCode: 'floor(floatResult)' inSmalltalk: [floatResult floor].
				floatsResult at: i put: (floatRcvr - (floatResult * floatArg)).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 1/21/2006 00:21'!
primitiveRemScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr wordsResult floatsResult floatsRcvr isArgInt intArg floatArg wordRcvr floatResult floatRcvr |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.
	self var: #floatResult declareC: 'double floatResult'.
	self var: #wordResult declareC: 'unsigned int wordResult'.
	self var: #floatRcvr declareC: 'double floatRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #wordRcvr declareC: 'unsigned int wordRcvr'.
	self var: #wordArg declareC: 'unsigned int wordArg'.


	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgInt & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) \\ intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordRcvr _ wordsRcvr at: i.
				floatResult _ wordRcvr / floatArg.
				floatResult _ self cCode: 'floor(floatResult)' inSmalltalk: [floatResult floor].
				floatsResult at: i put: wordRcvr - (floatResult * floatArg).
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatRcvr _ floatsRcvr at: i.
				floatResult _ floatRcvr / intArg.
				floatResult _ self cCode: 'floor(floatResult)' inSmalltalk: [floatResult floor].
				floatsResult at: i put: floatRcvr - (floatResult * intArg).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatRcvr _ floatsRcvr at: i.
				floatResult _ floatRcvr / floatArg.
				floatResult _ self cCode: 'floor(floatResult)' inSmalltalk: [floatResult floor].
				floatsResult at: i put: floatRcvr - (floatResult * floatArg).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveSubArrays

	| length resultOop argOop rcvrOop isArgWords isRcvrWords wordsRcvr wordsArg wordsResult floatsArg floatsResult floatsRcvr |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #wordsArg declareC: 'unsigned int *wordsArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatsArg declareC: 'float *floatsArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackObjectValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: argOop).
	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: argOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: rcvrOop)).
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgWords _ interpreterProxy is: argOop MemberOf: 'WordArray'.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgWords & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgWords ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) - (wordsArg at: i).
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) - (floatsArg at: i).
			].
		].
	] ifFalse: [
		isArgWords ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			wordsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) - (wordsArg at: i).
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatsArg _ interpreterProxy firstIndexableField: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) - (floatsArg at: i).
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'array arithmetic' stamp: 'yo 10/13/2005 01:28'!
primitiveSubScalar

	| length resultOop argOop rcvrOop isRcvrWords wordsRcvr wordsResult floatsResult floatsRcvr isArgInt intArg floatArg |

	self export: true.
	self inline: true.
	self var: #wordsRcvr declareC: 'unsigned int *wordsRcvr'.
	self var: #intArg declareC: 'int intArg'.
	self var: #wordsResult declareC: 'unsigned int *wordsResult'.
	self var: #floatsRcvr declareC: 'float *floatsRcvr'.
	self var: #floatArg declareC: 'double floatArg'.
	self var: #floatsResult declareC: 'float *floatsResult'.

	resultOop _ interpreterProxy stackObjectValue: 0.
	argOop _ interpreterProxy stackValue: 1.
	rcvrOop _ interpreterProxy stackObjectValue: 2.
	interpreterProxy failed ifTrue:[^nil].

	interpreterProxy success: (interpreterProxy isWords: rcvrOop).
	interpreterProxy success: (interpreterProxy isWords: resultOop).
	interpreterProxy failed ifTrue:[^nil].
	length _ interpreterProxy stSizeOf: rcvrOop.
	interpreterProxy success: (length = (interpreterProxy stSizeOf: resultOop)).
	interpreterProxy failed ifTrue:[^nil].

	isArgInt _ interpreterProxy isIntegerObject: argOop.
	isRcvrWords _ interpreterProxy is: rcvrOop MemberOf: 'WordArray'.

	isArgInt & isRcvrWords ifTrue: [
		(interpreterProxy is: resultOop MemberOf: 'WordArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	] ifFalse: [
		(interpreterProxy is: resultOop MemberOf: 'KedamaFloatArray') ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	isRcvrWords ifTrue: [
		isArgInt ifTrue: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			wordsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				wordsResult at: i put: (wordsRcvr at: i) - intArg.
			].
		] ifFalse: [
			wordsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (wordsRcvr at: i) - floatArg.
			].
		].
	] ifFalse: [
		isArgInt ifTrue: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			intArg _ interpreterProxy integerValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) - intArg.
			].
		] ifFalse: [
			floatsRcvr _ interpreterProxy firstIndexableField: rcvrOop.
			floatArg _ interpreterProxy floatValueOf: argOop.
			floatsResult _ interpreterProxy firstIndexableField: resultOop.
			0 to: length-1 do:[:i|
				floatsResult at: i put: (floatsRcvr at: i) - floatArg.
			].
		].
	].

	interpreterProxy pop: 4.
	interpreterProxy push: resultOop.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
primPixelAtXY

	| height width yPos xPos bitsOop x y bits index ret |
	self export: true.
	self inline: true.

	self var: 'bits' declareC: 'unsigned int *bits'.
	self var: 'xPos' declareC: 'double xPos'.
	self var: 'yPos' declareC: 'double yPos'.

	height _ interpreterProxy stackIntegerValue: 0.
	width _ interpreterProxy stackIntegerValue: 1.
	yPos _ interpreterProxy stackFloatValue: 2.
	xPos _ interpreterProxy stackFloatValue: 3.
	bitsOop _ interpreterProxy stackValue: 4.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: bitsOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: bitsOop) ~= (height * width) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	x _ xPos.
	y _ yPos.
	bits _ interpreterProxy firstIndexableField: bitsOop.

	((x >= 0) &  (x < width) & (y >= 0) & (y < height)) ifTrue: [
		index _ y * width + x.
		ret _ bits at: index.
	] ifFalse: [
		ret _ 0.
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 6.
	interpreterProxy pushInteger: ret.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
primPixelAtXYPut

	| height width value yPos xPos bitsOop x y v bits index |
	self export: true.
	self inline: true.

	self var: 'bits' declareC: 'unsigned int *bits'.
	self var: 'xPos' declareC: 'double xPos'.
	self var: 'yPos' declareC: 'double yPos'.

	height _ interpreterProxy stackIntegerValue: 0.
	width _ interpreterProxy stackIntegerValue: 1.
	value _ interpreterProxy stackIntegerValue: 2.
	yPos _ interpreterProxy stackFloatValue: 3.
	xPos _ interpreterProxy stackFloatValue: 4.
	bitsOop _ interpreterProxy stackValue: 5.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: bitsOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: bitsOop) ~= (height * width) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	x _ xPos.
	y _ yPos.
	v _ value.
	v > 16r3FFFFFFF ifTrue: [
		v _ 16r3FFFFFFF.
	].
	v < 0 ifTrue: [
		v _ 0.
	].

	bits _ interpreterProxy firstIndexableField: bitsOop.

	((x >= 0) &  (x < width) & (y >= 0) & (y < height)) ifTrue: [
		index _ y * width + x.
		bits at: index put: v.
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 6.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
primPixelsAtXY

	| yArray xArray bitsHeight bitsWidth bitsOop bits size x y bitsIndex destWordsOop  yArrayOop xArrayOop destWords  |
	self export: true.
	self inline: true.
	self var: 'destWords' declareC: 'unsigned int *destWords'.
	self var: 'bits' declareC: 'unsigned int *bits'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.

	destWordsOop _ interpreterProxy stackValue: 0.
	bitsHeight _ interpreterProxy stackIntegerValue: 1.
	bitsWidth _ interpreterProxy stackIntegerValue: 2.
	bitsOop _ interpreterProxy stackValue: 3.
	yArrayOop _ interpreterProxy stackValue: 4.
	xArrayOop _ interpreterProxy stackValue: 5.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: destWordsOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: bitsOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	(bitsHeight * bitsWidth) ~= (interpreterProxy slotSizeOf: bitsOop) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: xArrayOop.
	(interpreterProxy slotSizeOf: yArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: destWordsOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	xArray _ interpreterProxy firstIndexableField: xArrayOop.
	yArray _ interpreterProxy firstIndexableField: yArrayOop.
	destWords _ interpreterProxy firstIndexableField: destWordsOop.
	bits _ interpreterProxy firstIndexableField: bitsOop.

	0 to: size - 1 do: [:i |
		x _ self cCoerce: (xArray at: i) to: 'int'.
		self cCode: '' inSmalltalk: [x _ x asInteger].
		y _ self cCoerce: (yArray at: i) to: 'int'.
		self cCode: '' inSmalltalk: [y _ y asInteger].
		(((x >= 0) and: [y >= 0]) and: [(x < bitsWidth) and: [y < bitsHeight]]) ifTrue: [
			bitsIndex _ ((y * bitsWidth) + x).
			destWords at: i put: (bits at: bitsIndex).
		]
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 6.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
primScalarForward

	| bottomEdgeMode topEdgeMode rightEdgeMode leftEdgeMode destHeight destWidth headingOop yOop xOop size xArray yArray headingArray val dist newX newY index i |
	self export: true.
	self inline: true.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'val' declareC: 'double val'.
	self var: 'destHeight' declareC: 'double destHeight'.
	self var: 'destWidth' declareC: 'double destWidth'.
	self var: 'dist' declareC: 'double dist'.
	self var: 'newX' declareC: 'double newX'.
	self var: 'newY' declareC: 'double newY'.

	bottomEdgeMode _ interpreterProxy stackIntegerValue: 0.
	topEdgeMode _ interpreterProxy stackIntegerValue: 1.
	rightEdgeMode _ interpreterProxy stackIntegerValue: 2.
	leftEdgeMode _ interpreterProxy stackIntegerValue: 3.
	destHeight _ interpreterProxy stackFloatValue: 4.
	destWidth _ interpreterProxy stackFloatValue: 5.
	val _ interpreterProxy stackFloatValue: 6.
	headingOop _ interpreterProxy stackValue: 7.
	yOop _ interpreterProxy stackValue: 8.
	xOop _ interpreterProxy stackValue: 9.
	index _ interpreterProxy stackIntegerValue: 10.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: xOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: xOop.
	(interpreterProxy slotSizeOf: yOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: headingOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	xArray _ interpreterProxy firstIndexableField: xOop.
	yArray _ interpreterProxy firstIndexableField: yOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.

	dist _ val.
	i _ index - 1.
	newX _ (xArray at: i) + (dist * (headingArray at: i) cos).
	newY _ (yArray at: i) - (dist * (headingArray at: i) sin).
	self scalarXAt: i xArray: xArray headingArray: headingArray value: newX destWidth: destWidth leftEdgeMode: leftEdgeMode rightEdgeMode: rightEdgeMode.
	self scalarYAt: i yArray: yArray headingArray: headingArray value: newY destHeight: destHeight topEdgeMode: topEdgeMode bottomEdgeMode: bottomEdgeMode.

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 11.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 1/20/2006 14:02'!
primSetPixelsAtXY

	| yArray xArray bitsHeight bitsWidth bitsOop bits size x y bitsIndex  yArrayOop xArrayOop  valueOop isValueInt isValueWordArray intValue wordsValue value pArrayOop pArray floatsValue fv |
	self export: true.
	self inline: true.	
	self var: 'intValue' declareC: 'unsigned int intValue'.
	self var: 'wordsValue' declareC: 'unsigned int *wordsValue'.
	self var: 'floatsValue' declareC: 'float *floatsValue'.
	self var: 'value' declareC: 'unsigned int value'.
	self var: 'floatValue' declareC: 'float floatValue'.
	self var: 'bits' declareC: 'unsigned int *bits'.
	self var: 'pArray' declareC: 'unsigned char *pArray'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.

	valueOop _ interpreterProxy stackValue: 0.
	bitsHeight _ interpreterProxy stackIntegerValue: 1.
	bitsWidth _ interpreterProxy stackIntegerValue: 2.
	bitsOop _ interpreterProxy stackValue: 3.
	yArrayOop _ interpreterProxy stackValue: 4.
	xArrayOop _ interpreterProxy stackValue: 5.
	pArrayOop _ interpreterProxy stackValue: 6.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isBytes: pArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: bitsOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	(bitsHeight * bitsWidth) ~= (interpreterProxy slotSizeOf: bitsOop) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: xArrayOop.
	(interpreterProxy slotSizeOf: pArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: yArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	pArray _ interpreterProxy firstIndexableField: pArrayOop.
	xArray _ interpreterProxy firstIndexableField: xArrayOop.
	yArray _ interpreterProxy firstIndexableField: yArrayOop.

	isValueInt _ interpreterProxy isIntegerObject: valueOop.
	isValueInt ifTrue: [
		intValue _ interpreterProxy integerValueOf: valueOop.
		value _ intValue.
	] ifFalse: [
		(interpreterProxy slotSizeOf: valueOop) ~= size
			ifTrue: [interpreterProxy primitiveFail. ^ nil].
		isValueWordArray _ (interpreterProxy is: valueOop MemberOf: 'WordArray').
		isValueWordArray ifTrue: [
			wordsValue _ interpreterProxy firstIndexableField: valueOop.
		] ifFalse: [
			floatsValue _ interpreterProxy firstIndexableField: valueOop.
		].
	].
	bits _ interpreterProxy firstIndexableField: bitsOop.

	0 to: size - 1 do: [:i |
		(pArray at: i) = 1 ifTrue: [
			x _ self cCoerce: (xArray at: i) to: 'int'.
			self cCode: '' inSmalltalk: [x _ x asInteger].
			y _ self cCoerce: (yArray at: i) to: 'int'.
			self cCode: '' inSmalltalk: [y _ y asInteger].
			(((x >= 0) and: [y >= 0]) and: [(x < bitsWidth) and: [y < bitsHeight]]) ifTrue: [
				bitsIndex _ ((y * bitsWidth) + x).
				isValueInt ifFalse: [
					isValueWordArray ifTrue: [
						bits at: bitsIndex put: (wordsValue at: i).
					] ifFalse: [
						fv _ floatsValue at: i.
						self cCode: '' inSmalltalk: [fv _ fv asInteger].
						bits at: bitsIndex put: fv.
					].
				] ifTrue: [
					bits at: bitsIndex put: value.
				].
			]
		].
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 7.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 15:47'!
primTurtlesForward

	| bottomEdgeMode topEdgeMode rightEdgeMode leftEdgeMode destHeight destWidth valOop headingOop yOop xOop isValVector size xArray yArray headingArray valArray val dist newX newY pOop pArray |
	self export: true.
	self inline: true.
	self var: 'pArray' declareC: 'unsigned char *pArray'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'valArray' declareC: 'float *valArray'.
	self var: 'val' declareC: 'double val'.
	self var: 'destHeight' declareC: 'double destHeight'.
	self var: 'destWidth' declareC: 'double destWidth'.
	self var: 'dist' declareC: 'double dist'.
	self var: 'newX' declareC: 'double newX'.
	self var: 'newY' declareC: 'double newY'.

	bottomEdgeMode _ interpreterProxy stackIntegerValue: 0.
	topEdgeMode _ interpreterProxy stackIntegerValue: 1.
	rightEdgeMode _ interpreterProxy stackIntegerValue: 2.
	leftEdgeMode _ interpreterProxy stackIntegerValue: 3.
	destHeight _ interpreterProxy stackFloatValue: 4.
	destWidth _ interpreterProxy stackFloatValue: 5.
	valOop _ interpreterProxy stackValue: 6.
	headingOop _ interpreterProxy stackValue: 7.
	yOop _ interpreterProxy stackValue: 8.
	xOop _ interpreterProxy stackValue: 9.
	pOop _ interpreterProxy stackValue: 10.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isBytes: pOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isFloatObject: valOop) ifTrue: [
		isValVector _ false.
	] ifFalse: [
		(interpreterProxy isWords: valOop) ifTrue: [
			isValVector _ true
		] ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	size _ interpreterProxy slotSizeOf: xOop.
	(interpreterProxy slotSizeOf: yOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: headingOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: pOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	isValVector ifTrue: [
		(interpreterProxy slotSizeOf: valOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	pArray _ interpreterProxy firstIndexableField: pOop.
	xArray _ interpreterProxy firstIndexableField: xOop.
	yArray _ interpreterProxy firstIndexableField: yOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.
	isValVector ifTrue: [
		valArray _ interpreterProxy firstIndexableField: valOop.
	] ifFalse: [
		val _ interpreterProxy floatValueOf: valOop
	].

	0 to: size -1 do: [:i |
		(pArray at: i) = 1 ifTrue: [
			isValVector ifTrue: [
				dist _ valArray at: i.
			] ifFalse: [
				dist _ val.
			].
			newX _ (xArray at: i) + (dist * (headingArray at: i) cos).
			newY _ (yArray at: i) - (dist * (headingArray at: i) sin).
			self scalarXAt: i xArray: xArray headingArray: headingArray value: newX destWidth: destWidth leftEdgeMode: leftEdgeMode rightEdgeMode: rightEdgeMode.
			self scalarYAt: i yArray: yArray headingArray: headingArray value: newY destHeight: destHeight topEdgeMode: topEdgeMode bottomEdgeMode: bottomEdgeMode
		].
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 11.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
primUpHill

	| sniffRange height width bitsOop tH tY tX bits turtleX turtleY startX endX startY endY maxVal maxValX rowOffset thisVal maxValY ret |
	self inline: true.
	self export: true.

	self var: 'bits' declareC: 'unsigned int *bits'.
	self var: 'tX' declareC: 'double tX'.
	self var: 'tY' declareC: 'double tY'.
	self var: 'tH' declareC: 'double tH'.

	sniffRange _ interpreterProxy stackIntegerValue: 0.
	height _ interpreterProxy stackIntegerValue: 1.
	width _ interpreterProxy stackIntegerValue: 2.
	bitsOop _ interpreterProxy stackValue: 3.
	tH _ interpreterProxy stackFloatValue: 4.
	tY _ interpreterProxy stackFloatValue: 5.
	tX _ interpreterProxy stackFloatValue: 6.

	interpreterProxy failed ifTrue: [^ nil].
	(interpreterProxy isWords: bitsOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: bitsOop) ~= (height * width) ifTrue: [interpreterProxy primitiveFail. ^ nil].

	bits _ interpreterProxy firstIndexableField: bitsOop.

	turtleX _ self cCode: 'tX' inSmalltalk: [tX asInteger].
	turtleY _ self cCode: 'tY' inSmalltalk: [tY asInteger].
	turtleX _ turtleX max: 0.
	turtleY _ turtleY max: 0.
	turtleX _ turtleX min: width - 1.
	turtleY _ turtleY min: height - 1.
	startX _ turtleX - sniffRange max: 0.
	endX _ (turtleX + sniffRange) min: (width - 1).
	startY _ (turtleY - sniffRange) max: 0.
	endY _ (turtleY + sniffRange) min: (height - 1).
	maxVal _ bits at: turtleY * width + turtleX.
	maxValX _ -1.
	startY to: endY do: [:y | 
		rowOffset _ y * width.
		startX to: endX do: [:x | 
			thisVal _ bits at: rowOffset + x.
			thisVal > maxVal ifTrue: [
				maxValX _ x.
				maxValY _ y.
				maxVal _ thisVal
			].
		].
	].
	-1 = maxValX
		ifTrue: [ret _ self radiansToDegrees: tH]
		ifFalse: [
			ret _ (self degreesFromX: (self cCoerce: maxValX - turtleX to: 'double') y: (self cCoerce: maxValY - turtleY to: 'double')) + 90.0.
		].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 8.
	interpreterProxy pushFloat: ret.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
radiansToDegrees: radians

	| deg degrees |
	self inline: true.
	self returnTypeC: 'double'.
	self var: 'degrees' declareC: 'double degrees'.
	self var: 'deg' declareC: 'double deg'.
	self var: 'radians' declareC: 'double radians'.
	self var: 'headingRadians' declareC: 'double headingRadians'.

	degrees _ radians / 0.0174532925199433.
	deg _ 90.0 - degrees.
	deg > 0.0 ifFalse: [deg _ deg + 360.0].
	^ deg.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
randomIntoFloatArray

	| range factor floatArrayOop to from size floatArray |
	self export: true.
	self inline: true.
	self var: 'factor' declareC: 'double factor'.
	self var: 'floatArray' declareC: 'float *floatArray'.

	factor _ interpreterProxy stackFloatValue: 0.
	floatArrayOop _ interpreterProxy stackValue: 1.
	to _ interpreterProxy stackIntegerValue: 2.
	from _ interpreterProxy stackIntegerValue: 3.
	range _ interpreterProxy stackIntegerValue: 4.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: floatArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	size _ interpreterProxy stSizeOf: floatArrayOop.
	(size >= to and: [from >= 1 and: [to >= from]]) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	floatArray _ interpreterProxy firstIndexableField: floatArrayOop.
	interpreterProxy failed ifTrue: [^ nil].

	from to: to do: [:index |
		floatArray at: index-1 put: (self cCoerce: (self kedamaRandom2: range) to: 'double') * factor.
	].

	interpreterProxy pop: 5.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
randomIntoIntegerArray

	| range factor integerArrayOop to from size integerArray |
	self export: true.
	self inline: true.
	self var: 'factor' declareC: 'double factor'.
	self var: 'integerArray' declareC: 'unsigned int *integerArray'.

	factor _ interpreterProxy stackFloatValue: 0.
	integerArrayOop _ interpreterProxy stackValue: 1.
	to _ interpreterProxy stackIntegerValue: 2.
	from _ interpreterProxy stackIntegerValue: 3.
	range _ interpreterProxy stackIntegerValue: 4.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: integerArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	size _ interpreterProxy stSizeOf: integerArrayOop.
	(size >= to and: [from >= 1 and: [to >= from]]) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	integerArray _ interpreterProxy firstIndexableField: integerArrayOop.
	interpreterProxy failed ifTrue: [^ nil].

	from to: to do: [:index |
		integerArray at: index-1 put: (self cCoerce: ((self cCoerce: (self kedamaRandom2: range) to: 'double') * factor) to: 'int').
	].

	interpreterProxy pop: 5.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
randomRange

	| range ret |
	self export: true.
	self inline: true.
	range _ interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ nil].

	ret _ self kedamaRandom2: range.

	interpreterProxy failed ifTrue: [^ nil].

	interpreterProxy pop: 2.
	interpreterProxy pushInteger: ret.
	^ self.

	! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
scalarGetAngleTo

	| fromY fromX toY toX x y r |
	self export: true.
	self inline: true.
	self var: 'toX' declareC: 'double toX'.
	self var: 'toY' declareC: 'double toY'.
	self var: 'fromX' declareC: 'double fromX'.
	self var: 'fromY' declareC: 'double fromY'.
	self var: 'x' declareC: 'double x'.
	self var: 'y' declareC: 'double y'.
	self var: 'r' declareC: 'double r'.

	fromY _ interpreterProxy stackFloatValue: 0.
	fromX _ interpreterProxy stackFloatValue: 1.
	toY _ interpreterProxy stackFloatValue: 2.
	toX _ interpreterProxy stackFloatValue: 3.

	interpreterProxy failed ifTrue: [^ nil].

	x _ toX - fromX.
	y _ toY - fromY.

	r _ self degreesFromX: x y: y.
	r _ r + 90.0.
	r > 360.0 ifTrue: [r _ r - 360.0].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 5.
	interpreterProxy pushFloat: r.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
scalarGetDistanceTo

	| fromY fromX toY toX x y r |
	self export: true.
	self inline: true.
	self var: 'toX' declareC: 'double toX'.
	self var: 'toY' declareC: 'double toY'.
	self var: 'fromX' declareC: 'double fromX'.
	self var: 'fromY' declareC: 'double fromY'.
	self var: 'x' declareC: 'double x'.
	self var: 'y' declareC: 'double y'.
	self var: 'r' declareC: 'double r'.

	fromY _ interpreterProxy stackFloatValue: 0.
	fromX _ interpreterProxy stackFloatValue: 1.
	toY _ interpreterProxy stackFloatValue: 2.
	toX _ interpreterProxy stackFloatValue: 3.

	interpreterProxy failed ifTrue: [^ nil].

	x _ fromX - toX.
	y _ fromY - toY.

	r _ ((x * x) + (y * y)) sqrt.

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 5.
	interpreterProxy pushFloat: r.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
scalarXAt: index xArray: xArray headingArray: headingArray value: val destWidth: destWidth leftEdgeMode: leftEdgeMode rightEdgeMode: rightEdgeMode

	| newX headingRadians |
	self inline: true.

	self var: 'xArray' declareC: 'float* xArray'.
	self var: 'headingArray' declareC: 'float* headingArray'.
	self var: 'destWidth' declareC: 'double destWidth'.
	self var: 'val' declareC: 'double val'.
	self var: 'newX' declareC: 'double newX'.
	self var: 'headingRadians' declareC: 'double headingRadians'.

	newX _ val.
	newX < 0.0 ifTrue: [
		leftEdgeMode = 1 ifTrue: [
			"wrap"
			newX _ newX + destWidth.
		].
		leftEdgeMode = 2 ifTrue: [
			"stick"
			newX _ 0.0.
		].
		leftEdgeMode = 3 ifTrue: [
			"bounce"
			newX _ 0.0 - newX.
			headingRadians _ headingArray at: index.
			headingRadians <  3.141592653589793
				ifTrue: [headingArray at: index put: 3.141592653589793 - headingRadians]
				ifFalse: [headingArray at: index put: 9.42477796076938 - headingRadians].
		].
	].

	newX >= destWidth ifTrue: [
		rightEdgeMode = 1 ifTrue: [
			newX _ newX - destWidth.
		].
		rightEdgeMode = 2 ifTrue: [
			newX _ destWidth - 0.000001.
		].
		rightEdgeMode = 3 ifTrue: [
			newX _ (destWidth - 0.000001) - (newX - destWidth).
			headingRadians _ headingArray at: index.
			headingRadians < 3.141592653589793
				ifTrue: [headingArray at: index put: (3.141592653589793 - headingRadians)]
				ifFalse: [headingArray at: index put: (9.42477796076938 - headingRadians)].
		]
	].
	xArray at: index put: newX.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
scalarYAt: index yArray: yArray headingArray: headingArray value: val destHeight: destHeight topEdgeMode: topEdgeMode bottomEdgeMode: bottomEdgeMode

	| newY |
	self inline: true.

	self var: 'yArray' declareC: 'float* yArray'.
	self var: 'headingArray' declareC: 'float* headingArray'.
	self var: 'destHeight' declareC: 'double destHeight'.
	self var: 'val' declareC: 'double val'.
	self var: 'newY' declareC: 'double newY'.

	newY _ val.
	newY < 0.0 ifTrue: [
		topEdgeMode = 1 ifTrue: [
			"wrap"
			newY _ newY + destHeight.
		].
		topEdgeMode = 2 ifTrue: [
			"stick"
			newY _ 0.0.
		].
		topEdgeMode = 3 ifTrue: [
			"bounce"
			newY _ 0.0 - newY.
			headingArray at: index put: (6.283185307179586 - (headingArray at: index)).
		].
	].

	newY >= destHeight ifTrue: [
		bottomEdgeMode = 1 ifTrue: [
			newY _ newY - destHeight.
		].
		bottomEdgeMode = 2 ifTrue: [
			newY _ destHeight - 0.000001.
		].
		bottomEdgeMode = 3 ifTrue: [
			newY _ (destHeight - 0.000001) - (newY - destHeight).
			headingArray at: index put: (6.283185307179586 - (headingArray at: index)).
		]
	].
	yArray at: index put: newY.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 15:03'!
setHeadingArrayFrom

	| resultOop headingOop size headingArray resultArray heading isValVector pOop pArray |
	self export: true.
	self inline: true.
	self var: 'pArray' declareC: 'unsigned char *pArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'resultArray' declareC: 'float *resultArray'.
	self var: 'heading' declareC: 'double heading'.

	resultOop _ interpreterProxy stackValue: 0.
	headingOop _ interpreterProxy stackValue: 1.
	pOop _ interpreterProxy stackValue: 2.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isBytes: pOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	size _ interpreterProxy slotSizeOf: headingOop.
	(interpreterProxy isFloatObject: resultOop) ifTrue: [
		isValVector _ false.
	] ifFalse: [
		(interpreterProxy isWords: resultOop) ifTrue: [
			(interpreterProxy slotSizeOf: resultOop) ~= size
				ifTrue: [interpreterProxy primitiveFail. ^ nil].
			isValVector _ true
		] ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	pArray _ interpreterProxy firstIndexableField: pOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.
	isValVector ifTrue: [
		resultArray _ interpreterProxy firstIndexableField: resultOop.
	] ifFalse: [
		heading _ interpreterProxy floatValueOf: resultOop.
		heading _ self degreesToRadians: heading.
	].

	0 to: size - 1 do: [:i |
		(pArray at: i) = 1 ifTrue: [
			isValVector ifTrue: [
				heading _ resultArray at: i.
				heading _ self degreesToRadians: heading.
			].
			headingArray at: i put: heading.
		].
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 3.

	! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
setScalarHeading

	| headingOop headingArray heading index |
	self export: true.
	self inline: true.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'heading' declareC: 'double heading'.

	heading _ interpreterProxy stackFloatValue: 0.
	headingOop _ interpreterProxy stackValue: 1.
	index _ interpreterProxy stackIntegerValue: 2.
	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	(interpreterProxy slotSizeOf: headingOop) < index ifTrue: [interpreterProxy primitiveFail. ^ nil].

	headingArray _ interpreterProxy firstIndexableField: headingOop.

	headingArray at: index - 1 put: (self degreesToRadians: heading).

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 3.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
shutdownModule

	self export: true.
	^ true.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
turtleScalarSetX

	| xArray headingArray val destWidth xOop headingOop leftEdgeMode rightEdgeMode xIndex size |
	self export: true.
	self inline: true.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'val' declareC: 'double val'.
	self var: 'destWidth' declareC: 'double destWidth'.

	rightEdgeMode _ interpreterProxy stackIntegerValue: 0.
	leftEdgeMode _ interpreterProxy stackIntegerValue: 1.
	destWidth _ interpreterProxy stackFloatValue: 2.
	val _ interpreterProxy stackFloatValue: 3.
	headingOop _ interpreterProxy stackValue: 4.
	xIndex _ interpreterProxy stackIntegerValue: 5.
	xOop _ interpreterProxy stackValue: 6.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: xOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: xOop.
	(interpreterProxy slotSizeOf: headingOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	xArray _ interpreterProxy firstIndexableField: xOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.

	self scalarXAt: xIndex - 1 xArray: xArray headingArray: headingArray value: val destWidth: destWidth leftEdgeMode: leftEdgeMode rightEdgeMode: rightEdgeMode.
	
	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 7.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
turtleScalarSetY

	| yArray headingArray val destHeight yOop headingOop size yIndex topEdgeMode bottomEdgeMode |
	self export: true.
	self inline: true.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'val' declareC: 'double val'.
	self var: 'destHeight' declareC: 'double destHeight'.

	bottomEdgeMode _ interpreterProxy stackIntegerValue: 0.
	topEdgeMode _ interpreterProxy stackIntegerValue: 1.
	destHeight _ interpreterProxy stackFloatValue: 2.
	val _ interpreterProxy stackFloatValue: 3.
	headingOop _ interpreterProxy stackValue: 4.
	yIndex _ interpreterProxy stackIntegerValue: 5.
	yOop _ interpreterProxy stackValue: 6.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: yOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy slotSizeOf: yOop.
	(interpreterProxy slotSizeOf: headingOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	yArray _ interpreterProxy firstIndexableField: yOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.

	self scalarYAt: yIndex - 1 yArray: yArray headingArray: headingArray value: val destHeight: destHeight topEdgeMode: topEdgeMode bottomEdgeMode: bottomEdgeMode.

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 7.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 1/20/2006 22:05'!
turtlesSetX

	| xArray headingArray valArray val destWidth xOop headingOop valOop leftEdgeMode rightEdgeMode isValVector size newX pOop pArray isWordVector wordValArray |
	self export: true.
	self inline: true.
	
	self var: 'pArray' declareC: 'unsigned char *pArray'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'valArray' declareC: 'float *valArray'.
	self var: 'wordValArray' declareC: 'unsigned int *wordValArray'.
	self var: 'val' declareC: 'double val'.
	self var: 'destWidth' declareC: 'double destWidth'.
	self var: 'newX' declareC: 'double newX'.

	rightEdgeMode _ interpreterProxy stackIntegerValue: 0.
	leftEdgeMode _ interpreterProxy stackIntegerValue: 1.
	destWidth _ interpreterProxy stackFloatValue: 2.
	valOop _ interpreterProxy stackValue: 3.
	headingOop _ interpreterProxy stackValue: 4.
	xOop _ interpreterProxy stackValue: 5.
	pOop _ interpreterProxy stackValue: 6.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isBytes: pOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isFloatObject: valOop) ifTrue: [
		isValVector _ false
	] ifFalse: [
		(interpreterProxy isWords: valOop) ifTrue: [
			isValVector _ true.
			isWordVector _ interpreterProxy is: valOop MemberOf: 'WordArray'.
		] ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	size _ interpreterProxy slotSizeOf: xOop.
	(interpreterProxy slotSizeOf: pOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: headingOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	isValVector ifTrue: [
		(interpreterProxy slotSizeOf: valOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	pArray _ interpreterProxy firstIndexableField: pOop.
	xArray _ interpreterProxy firstIndexableField: xOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.
	isValVector ifTrue: [
		isWordVector ifTrue: [
			wordValArray _ interpreterProxy firstIndexableField: valOop.
		] ifFalse: [
			valArray _ interpreterProxy firstIndexableField: valOop.
		].
	] ifFalse: [
		val _ interpreterProxy floatValueOf: valOop
	].

	0 to: size - 1 do: [:i |
		(pArray at: i) = 1 ifTrue: [
			isValVector ifTrue: [
				isWordVector ifTrue: [
					newX _ wordValArray at: i.
					self cCode: '' inSmalltalk: [newX _ newX asFloat].
				] ifFalse: [
					newX _ valArray at: i.
				].
			] ifFalse: [
				newX _ val.
			].
			self scalarXAt: i xArray: xArray headingArray: headingArray value: newX destWidth: destWidth leftEdgeMode: leftEdgeMode rightEdgeMode: rightEdgeMode.
		].
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 7.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 1/20/2006 22:03'!
turtlesSetY

	| yArray headingArray valArray val destHeight yOop headingOop valOop topEdgeMode bottomEdgeMode isValVector size newY pOop pArray isWordVector wordValArray |
	self export: true.
	self inline: true.
	self var: 'pArray' declareC: 'unsigned char *pArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'headingArray' declareC: 'float *headingArray'.
	self var: 'valArray' declareC: 'float *valArray'.
	self var: 'wordValArray' declareC: 'unsigned int *wordValArray'.
	self var: 'val' declareC: 'double val'.
	self var: 'destHeight' declareC: 'double destHeight'.
	self var: 'newY' declareC: 'double newY'.

	bottomEdgeMode _ interpreterProxy stackIntegerValue: 0.
	topEdgeMode _ interpreterProxy stackIntegerValue: 1.
	destHeight _ interpreterProxy stackFloatValue: 2.
	valOop _ interpreterProxy stackValue: 3.
	headingOop _ interpreterProxy stackValue: 4.
	yOop _ interpreterProxy stackValue: 5.
	pOop _ interpreterProxy stackValue: 6.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isBytes: pOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: headingOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isFloatObject: valOop) ifTrue: [
		isValVector _ false
	] ifFalse: [
		(interpreterProxy isWords: valOop) ifTrue: [
			isValVector _ true.
			isWordVector _ interpreterProxy is: valOop MemberOf: 'WordArray'.
		] ifFalse: [
			interpreterProxy primitiveFail. ^ nil
		].
	].

	size _ interpreterProxy slotSizeOf: yOop.
	(interpreterProxy slotSizeOf: pOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy slotSizeOf: headingOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	isValVector ifTrue: [
		(interpreterProxy slotSizeOf: valOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	pArray _ interpreterProxy firstIndexableField: pOop.
	yArray _ interpreterProxy firstIndexableField: yOop.
	headingArray _ interpreterProxy firstIndexableField: headingOop.
	isValVector ifTrue: [
		isWordVector ifTrue: [
			wordValArray _ interpreterProxy firstIndexableField: valOop.
		] ifFalse: [
			valArray _ interpreterProxy firstIndexableField: valOop.
		].
	] ifFalse: [
		val _ interpreterProxy floatValueOf: valOop
	].

	0 to: size - 1 do: [:i |
		(pArray at: i) = 1 ifTrue: [
			isValVector ifTrue: [
				isWordVector ifTrue: [
					newY _ wordValArray at: i.
					self cCode: '' inSmalltalk: [newY _ newY asFloat].
				] ifFalse: [
					newY _ valArray at: i.
				].
			] ifFalse: [
				newY _ val.
			].
			self scalarYAt: i yArray: yArray headingArray: headingArray value: newY destHeight: destHeight topEdgeMode: topEdgeMode bottomEdgeMode: bottomEdgeMode.
		].
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 7.
! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
vectorGetAngleTo

	| x y resultOop yArrayOop xArrayOop pYOop pXOop size isVector result xArray yArray pX pY ppx ppy r |
	self export: true.
	self inline: true.
	self var: 'x' declareC: 'double x'.
	self var: 'y' declareC: 'double y'.
	self var: 'result' declareC: 'float *result'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'pX' declareC: 'float *pX'.
	self var: 'pY' declareC: 'float *pY'.
	self var: 'ppx' declareC: 'double ppx'.
	self var: 'ppy' declareC: 'double ppy'.

	resultOop _ interpreterProxy stackValue: 0.
	yArrayOop _ interpreterProxy stackValue: 1.
	xArrayOop _ interpreterProxy stackValue: 2.
	pYOop _ interpreterProxy stackValue: 3.
	pXOop _ interpreterProxy stackValue: 4.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: resultOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy stSizeOf: resultOop.
	size < 0 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy stSizeOf: xArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy stSizeOf: yArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	(interpreterProxy isFloatObject: pXOop) ifTrue: [
		(interpreterProxy isFloatObject: pYOop)
			ifTrue: [isVector _ false]
			ifFalse: [interpreterProxy primitiveFail. ^ nil].

	] ifFalse: [
		(interpreterProxy isFloatObject: pYOop)
			ifFalse: [isVector _ true]
			ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	isVector ifTrue: [
		(interpreterProxy stSizeOf: pXOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
		(interpreterProxy stSizeOf: pYOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	result _ interpreterProxy firstIndexableField: resultOop.
	xArray _ interpreterProxy firstIndexableField: xArrayOop.
	yArray _ interpreterProxy firstIndexableField: yArrayOop.
	isVector ifTrue: [
		pX _ interpreterProxy firstIndexableField: pXOop.
		pY _ interpreterProxy firstIndexableField: pYOop.
	].

	isVector ifFalse: [
		ppx _ interpreterProxy floatValueOf: pXOop.
		ppy _ interpreterProxy floatValueOf: pYOop.
	].

	0 to: size - 1 do: [:index |
		isVector ifTrue: [
			ppx _ pX at: index.
			ppy _ pY at: index.
		].

		x _ ppx - (xArray at: index).
		y _ ppy - (yArray at: index).
		r _ self degreesFromX: x y: y.
		r _ r + 90.0.
		r > 360.0 ifTrue: [r _ r - 360.0].

		result at: index put: r.
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 6.
	interpreterProxy push: resultOop.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
vectorGetDistanceTo

	| x y resultOop yArrayOop xArrayOop pYOop pXOop size isVector result xArray yArray pX pY ppx ppy |
	self export: true.
	self inline: true.
	self var: 'x' declareC: 'double x'.
	self var: 'y' declareC: 'double y'.
	self var: 'result' declareC: 'float *result'.
	self var: 'xArray' declareC: 'float *xArray'.
	self var: 'yArray' declareC: 'float *yArray'.
	self var: 'pX' declareC: 'float *pX'.
	self var: 'pY' declareC: 'float *pY'.
	self var: 'ppx' declareC: 'double ppx'.
	self var: 'ppy' declareC: 'double ppy'.

	resultOop _ interpreterProxy stackValue: 0.
	yArrayOop _ interpreterProxy stackValue: 1.
	xArrayOop _ interpreterProxy stackValue: 2.
	pYOop _ interpreterProxy stackValue: 3.
	pXOop _ interpreterProxy stackValue: 4.

	interpreterProxy failed ifTrue: [^ nil].

	(interpreterProxy isWords: resultOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: xArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy isWords: yArrayOop) ifFalse: [interpreterProxy primitiveFail. ^ nil].

	size _ interpreterProxy stSizeOf: resultOop.
	size < 0 ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy stSizeOf: xArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	(interpreterProxy stSizeOf: yArrayOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].

	(interpreterProxy isFloatObject: pXOop) ifTrue: [
		(interpreterProxy isFloatObject: pYOop)
			ifTrue: [isVector _ false]
			ifFalse: [interpreterProxy primitiveFail. ^ nil].

	] ifFalse: [
		(interpreterProxy isFloatObject: pYOop)
			ifFalse: [isVector _ true]
			ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	isVector ifTrue: [
		(interpreterProxy stSizeOf: pXOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
		(interpreterProxy stSizeOf: pYOop) ~= size ifTrue: [interpreterProxy primitiveFail. ^ nil].
	].

	result _ interpreterProxy firstIndexableField: resultOop.
	xArray _ interpreterProxy firstIndexableField: xArrayOop.
	yArray _ interpreterProxy firstIndexableField: yArrayOop.
	isVector ifTrue: [
		pX _ interpreterProxy firstIndexableField: pXOop.
		pY _ interpreterProxy firstIndexableField: pYOop.
	].

	isVector ifFalse: [
		ppx _ interpreterProxy floatValueOf: pXOop.
		ppy _ interpreterProxy floatValueOf: pYOop.
	].

	0 to: size - 1 do: [:index |
		isVector ifTrue: [
			ppx _ pX at: index.
			ppy _ pY at: index.
		].

		x _ ppx - (xArray at: index).
		y _ ppy - (yArray at: index).
		result at: index put: ((x * x) + (y * y)) sqrt.
	].

	interpreterProxy failed ifTrue: [^ nil].
	interpreterProxy pop: 6.
	interpreterProxy push: resultOop.

! !

!KedamaPlugin2 methodsFor: 'primitives' stamp: 'yo 10/13/2005 01:28'!
zoomBitmap

	| yFactor xFactor sHeight sWidth dst src srcSize dstSize sOrigin dOrigin srcIndex bit dstIndex srcOrigin |

	self export: true.
	self inline: true.
	self var: 'sOrigin' declareC: 'unsigned int* sOrigin'.
	self var: 'dOrigin' declareC: 'unsigned int* dOrigin'.

	yFactor _ interpreterProxy stackIntegerValue: 0.
	xFactor _ interpreterProxy stackIntegerValue: 1.
	sHeight _ interpreterProxy stackIntegerValue: 2.
	sWidth _ interpreterProxy stackIntegerValue: 3.
	dst _ interpreterProxy stackValue: 4.
	src _ interpreterProxy stackValue: 5.

	interpreterProxy failed ifTrue: [^ nil].

	srcSize _ interpreterProxy slotSizeOf: src.
	dstSize _ interpreterProxy slotSizeOf: dst.

	(sWidth * sHeight) = srcSize ifFalse: [interpreterProxy primitiveFail. ^ nil].
	(srcSize * xFactor * yFactor) = dstSize ifFalse: [interpreterProxy primitiveFail. ^ nil].

	sOrigin _ interpreterProxy firstIndexableField: src.
	dOrigin _ interpreterProxy firstIndexableField: dst.

	srcIndex _ 0.
	srcOrigin _ 0.
	dstIndex _ 0.
	0 to: sHeight - 1 do: [:sy |
		0 to: yFactor - 1 do: [:y |
			0 to: sWidth - 1 do: [:sx |
				bit _ sOrigin at: srcIndex.
				srcIndex _ srcIndex + 1.
				0 to: xFactor - 1 do: [:dummy |
					dOrigin at: dstIndex put: bit.
					dstIndex _ dstIndex + 1.
				].
			].
			srcIndex _ srcOrigin.
		].
		srcOrigin _ srcOrigin + sWidth.
		srcIndex _ srcOrigin.
	].

	interpreterProxy pop: 6.
! !

ProtoObject subclass: #VideoForLinuxPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EtoysPlugins-VideoForSqueak'!

!VideoForLinuxPlugin commentStamp: 'dgd 8/1/2004 21:04' prior: 0!
Plugin to access Video4Linux devices.
!

!VideoForLinuxPlugin class methodsFor: 'translation' stamp: 'dgd 6/26/2004 18:12'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with 
	the plugin, here is where you want to flag"
	^ true! !

!VideoForLinuxPlugin class methodsFor: 'translation' stamp: 'dgd 2/28/2007 16:53'!
translateIn: fullDirectoryPathString
	" 
	VideoForLinuxPlugin translateIn: '/home/dgd/squeak-vm37/src/plugins/VideoForLinuxPlugin/'.
	VideoForLinuxPlugin translateIn: '/home/dgd/SqueakVMSource/squeak-svn/platforms/unix/plugins/VideoForLinuxPlugin/'.
	"
	| directory |
	directory := FileDirectory forFileName: fullDirectoryPathString.
	directory assureExistence.
	self translateInDirectory: directory doInlining: true.
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/1/2007 17:45'!
clipPixel: pixel
	| result |
	self inline: true.
	result := pixel max: 0.
	^ result min: 255.
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 13:08'!
copyFrom: src2 into16: dest2 destSize: destSize brightness: brightness contrast: contrast 
	|  dest src final |
	self inline: true.
	self var: #device		type: 'Device'.
	self var: #brightness	type: 'double'.
	self var: #contrast		type: 'double'.
	self var: #dest2		type: 'unsigned char*'.
	self var: #dest			type: 'unsigned char*'.
	self var: #src2			type: 'unsigned char*'.
	self var: #src			type: 'unsigned char*'.
	self var: #final			type: 'unsigned char*'.
	self var: #cont			type: 'double'.
	dest := dest2.
	src := src2.
	final := dest + (destSize * 2).
	(contrast = 0.0 and: [brightness = 0.0]) ifTrue: [
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				into16Bits: dest.
			dest := dest + 2.
			src := src + 3.
		].
	]
	ifFalse: [
		| brig256 cont contInteger |
		brig256 := (brightness * 256) asInteger.
		cont := 1.0 + contrast.
		contInteger := (cont * cont * 32767) asInteger.
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				brightness256: brig256 contrastFactor2: contInteger
				into16Bits: dest.
			dest := dest + 2.
			src := src + 3.
		].
	].
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 13:08'!
copyFrom: src2 into32: dest2 destSize: destSize brightness: brightness contrast: contrast 
	|  dest src final |
	self inline: true.
	self var: #device		type: 'Device'.
	self var: #brightness	type: 'double'.
	self var: #contrast		type: 'double'.
	self var: #dest2		type: 'unsigned char*'.
	self var: #dest			type: 'unsigned char*'.
	self var: #src2			type: 'unsigned char*'.
	self var: #src			type: 'unsigned char*'.
	self var: #final			type: 'unsigned char*'.
	self var: #cont			type: 'double'.
	dest := dest2.
	src := src2.
	final := dest + (destSize * 4).
	(contrast = 0.0 and: [brightness = 0.0]) ifTrue: [
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				into32Bits: dest.
			dest := dest + 4.
			src := src + 3.
		].
	]
	ifFalse: [
		| brig256 cont contInteger |
		brig256 := (brightness * 256) asInteger.
		cont := 1.0 + contrast.
		contInteger := (cont * cont * 32767) asInteger.
		[dest < final] whileTrue: [
			self
				storeRed: (src at: 0) green: (src at: 1) blue: (src at: 2)
				brightness256: brig256 contrastFactor2: contInteger
				into32Bits: dest.
			dest := dest + 4.
			src := src + 3.
		].
	].
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/2/2007 15:30'!
height: device 
	self inline: true.
	self var: #device type: 'Device'.
	^ self cCode: 'device->vwindow.height'! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/1/2007 17:46'!
pixel: pixel brightness256: brightness contrastFactor2: contrastFactor 
	| result |
	self inline: true.
	result := (pixel - 128 * (contrastFactor / 32767.0)) asInteger + 128 + brightness.
	^ result.
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 8/1/2004 20:41'!
primitiveDeviceClose
	| device |
	self export: true. 
	self var: #device type: 'Device'.
	device := self
				cCoerce: (interpreterProxy stackIntegerValue: 0)
				to: 'Device'.
	self closeDevice: device.
	""
	interpreterProxy pop: 1! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 8/5/2004 22:27'!
primitiveDeviceCreate
	| palette height width devicePointer deviceID |
	self export: true.
	""
	palette := interpreterProxy stackIntegerValue: 0.
	height := interpreterProxy stackIntegerValue: 1.
	width := interpreterProxy stackIntegerValue: 2.
	deviceID := interpreterProxy stackIntegerValue: 3.
	""
	devicePointer := self cCode: '(int) createDevice(deviceID, width, height, palette)'.
	devicePointer <= 0
		ifTrue: [^ interpreterProxy primitiveFail].
	""
	interpreterProxy
		pop: 5
		thenPush: (interpreterProxy integerObjectOf: devicePointer) ! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 11:12'!
primitiveDeviceDescribe
	| deviceID deviceName deviceNamePointer deviceNameSize |
	self export: true.
	self var: #deviceNamePointer type: 'char*'.
	deviceName := interpreterProxy stackValue: 0.
	(interpreterProxy isBytes: deviceName)
		ifFalse: [^ interpreterProxy primitiveFail].
	deviceNamePointer := interpreterProxy firstIndexableField: deviceName.
	deviceNameSize := interpreterProxy byteSizeOf: deviceName.
	deviceNameSize = 32
		ifFalse: [^ interpreterProxy primitiveFail].
	deviceID := interpreterProxy stackIntegerValue: 1.
	self cCode: 'describeDevice(deviceID, deviceNamePointer)'.
	interpreterProxy pop: 2.
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 11:05'!
primitiveDeviceGetHeight
	| device result |
	self export: true.
	self var: #device type: 'Device'.
	device := self cCoerce: (interpreterProxy stackIntegerValue: 0) to: 'Device'.
	result := self cCode: 'device->vwindow.height'.
	interpreterProxy
			pop: 2
			thenPush: (interpreterProxy integerObjectOf: result)! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 11:05'!
primitiveDeviceGetWidth
	| device result |
	self export: true.
	self var: #device type: 'Device'.
	device := self cCoerce: (interpreterProxy stackIntegerValue: 0) to: 'Device'.
	result := self cCode: 'device->vwindow.width'.
	interpreterProxy
			pop: 2
			thenPush: (interpreterProxy integerObjectOf: result).
! !

!VideoForLinuxPlugin methodsFor: 'primitives' stamp: 'dgd 3/7/2007 14:25'!
primitiveDeviceNextFrameIntoBrightnessContrastFormDepth
	| formDepth contrast brightness bitsArrayPointer device src |
	self export: true.
	self var: #device		type: 'Device'.
	self var: #brightness 	type: 'double'.
	self var: #contrast		type: 'double'.
	self var: #src			type: 'unsigned char*'.
	formDepth := interpreterProxy stackIntegerValue: 0.
	contrast := interpreterProxy stackFloatValue: 1.
	contrast := contrast min: 1.0.
	contrast := contrast max: -1.0.
	brightness := interpreterProxy stackFloatValue: 2.
	brightness := brightness min: 1.0.
	brightness := brightness max: -1.0.
	bitsArrayPointer := interpreterProxy stackValue: 3.
	interpreterProxy success: (interpreterProxy isPointers: bitsArrayPointer) not.
	interpreterProxy failed ifTrue: [^nil].
	device := self cCoerce: (interpreterProxy stackIntegerValue: 4) to: 'Device'.
	"Capture"
	(self captureFrameFromDevice: device)
		ifFalse: [^interpreterProxy primitiveFail].
	"Convert to RGB24"
	(self convertBufferTo24: device)
		ifFalse: [^interpreterProxy primitiveFail].
	src := self cCode: 'device->buffer24'.
	"Convert"
	(formDepth = 16) ifTrue:[
		self
			copyFrom: src
			into16: (self cCoerce: (interpreterProxy firstIndexableField: bitsArrayPointer) to: 'unsigned char*')
			destSize: device width * device height
			brightness: brightness
			contrast: contrast.
	]
	ifFalse:[
		self
			copyFrom: src
			into32: (self cCoerce: (interpreterProxy firstIndexableField: bitsArrayPointer) to: 'unsigned char*')
			destSize: device width * device height
			brightness: brightness contrast: contrast.
	].
	interpreterProxy pop: 5.
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 12:56'!
storeRed: red green: green blue: blue brightness256: brig256 contrastFactor2: contInteger into16Bits: dest
	| r g b sr sg sb |
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	r := self pixel: red brightness256: brig256 contrastFactor2: contInteger.
	r := self clipPixel: r.
	g := self pixel: green brightness256: brig256 contrastFactor2: contInteger.
	g := self clipPixel: g.
	b := self pixel: blue brightness256: brig256 contrastFactor2: contInteger.
	b := self clipPixel: b.
	sr := r bitShift: -3.
	sg := g bitShift: -3.
	sb := b bitShift: -3.
	dest at: 0 put: ((sg bitShift: 5) bitOr: sb).
	dest at: 1 put: (((sr bitShift: 2) bitOr: (sg bitShift: -3)) bitOr: 128 "alpha bit").
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 10:54'!
storeRed: red green: green blue: blue brightness256: brig256 contrastFactor2: contInteger into32Bits: dest
	| r g b |
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	r := self pixel: red brightness256: brig256 contrastFactor2: contInteger.
	r := self clipPixel: r.
	g := self pixel: green brightness256: brig256 contrastFactor2: contInteger.
	g := self clipPixel: g.
	b := self pixel: blue brightness256: brig256 contrastFactor2: contInteger.
	b := self clipPixel: b.
	dest at: 0 put: b.
	dest at: 1 put: g.
	dest at: 2 put: r.
	dest at: 3 put: 255.	"alpha"
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 12:56'!
storeRed: red green: green blue: blue into16Bits: dest
	| sr sg sb |
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	sr := red bitShift: -3.
	sg := green bitShift: -3.
	sb := blue bitShift: -3.
	dest at: 0 put: ((sg bitShift: 5) bitOr: sb).
	dest at: 1 put: (((sr bitShift: 2) bitOr: (sg bitShift: -3)) bitOr: 128 "alpha bit").
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 10:53'!
storeRed: red green: green blue: blue into32Bits: dest
	self inline: true.
	self var: #dest type: 'unsigned char*'.
	dest at: 0 put: blue.
	dest at: 1 put: green.
	dest at: 2 put: red.
	dest at: 3 put: 255.	"alpha"
! !

!VideoForLinuxPlugin methodsFor: 'helper functions' stamp: 'dgd 3/7/2007 10:00'!
width: device 
	self inline: true.
	self var: #device type: 'Device'.
	^ self cCode: 'device->vwindow.width'! !

Object subclass: #ScratchPlugin
	instanceVariableNames: ''
	classVariableNames: 'TestFileName'
	poolDictionaries: ''
	category: 'EtoysPlugins-Scratch'!

!ScratchPlugin commentStamp: '<historical>' prior: 0!
Copyright (c) 2008 Massachusetts Institute of Technology
The ScratchPlugin is reused with permission from the ScratchCode1.3.1 release.
Thanks to Mitchel Resnick, John Maloney, and the other Lifelong Kindergardeners!! 
----------------------------------------------------------------------------------------------------

This plugin combines a number of primitives needed by Scratch including:

  a. primitives that manipulate 24-bit color images (i.e. 32-bit deep Forms but alpha is ignored)
  b. primitive to open browsers, find the user's documents folder, set the window title and other host OS functions

This plugin includes new serial port primitives, including support for named serial ports. The underlying plugin code can support up to 32 simultaenously open ports.

Port options for Set/GetOption primitives:
  1. baud rate
  2. data bits
  3. stop bits
  4. parity type
  5. input flow control type
  6. output flow control type

Handshake lines (options 20-25 for Set/GetOption primitives):
  20. DTR	(output line)
  21. RTS	(output line)
  22. CTS	(input line)
  23. DSR	(input line)
  24. CD		(input line)
  25. RI		(input line)
!

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
blurTest: count
	"self blurTest: 10"

	| f outBits |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	f display.
	count timesRepeat: [
		outBits _ f bits copy.
		self primBlur: f bits into: outBits width: f width.
		f bits: outBits.
		f display].
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
brightnessShiftTest
	"self brightnessShiftTest"

	| f fOut shift |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	[Sensor anyButtonPressed] whileFalse: [
		shift _ ((Sensor cursorPoint x - Display center x) * 220) // Display width.
		self primShiftBrightness: f bits into: fOut bits by: shift.
		fOut display].
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/31/2005 10:01'!
closePort: portNum
	"Close the given port."
	"self closePort: 1"

	<primitive: 'primClose' module: 'ScratchPlugin'>
! !

!ScratchPlugin class methodsFor: 'sound buffer utilities' stamp: 'jm 11/22/2006 19:40'!
compactSound: aSoundBuffer by: log2
	"Collapse the given by cutting in half log2 times."
	"self compactSound: (SoundBuffer fromArray: (1 to: 100) asArray) by: 3"

	| buf |
	buf _ aSoundBuffer.
	log2 timesRepeat: [buf _ self extractChannelFrom: buf rightFlag: false].
	^ buf
! !

!ScratchPlugin class methodsFor: 'sound buffer utilities' stamp: 'jm 11/21/2006 21:22'!
condenseSoundBuffer: aSoundBuffer by: factor
	"Condense the given SoundBuffer by the given factor. The result is a SoundBuffer 1/factor of the original size in which each sample represents the peak signal value over factor samples of the source."
	"self condenseSoundBuffer: (SoundBuffer fromArray: (1 to: 100) asArray) by: 10"

	| result |
	result _ SoundBuffer newMonoSampleCount: (aSoundBuffer size + factor - 1) // factor.
	self primCondense: aSoundBuffer into: result by: factor.
	^ result
! !

!ScratchPlugin class methodsFor: 'translation' stamp: 'jm 6/22/2007 21:44'!
declareCVarsIn: aCCodeGenerator
	"self translate"

	super declareCVarsIn: aCCodeGenerator.
	aCCodeGenerator cExtras: '
#include "scratchOps.h"
#include <math.h>
'.! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
doubleTest
	"self doubleTest"

	| f fOut |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ Form extent: (2 * f extent) + 20 depth: 32.
	self primDouble: f bits w: f width h: f height into: fOut bits w: fOut width h: fOut height x: 9 y: 10.
	fOut display.

! !

!ScratchPlugin class methodsFor: 'sound buffer utilities' stamp: 'jm 11/21/2006 21:22'!
extractChannelFrom: aSoundBuffer rightFlag: rightFlag
	"Extract one channel from the given stereo sound buffer. If rightFlag is true, extract the right channel; otherwise, extract the left one."
	"self extractChannelFrom: (SoundBuffer fromArray: #(1 2 3 4)) rightFlag: true"

	| result |
	result _ SoundBuffer newMonoSampleCount: aSoundBuffer size // 2.
	self primExtractChannelFrom: aSoundBuffer into: result rightFlag: rightFlag.
	^ result
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
fishEye: inForm out: outForm power: power

	| height sz centerX centerY dx dy ang pix  width r srcX srcY |
	"calculate height, center, scales, radius, whirlRadians, and radiusSquared"
	sz _ inForm bits size.
	width _ inForm width.

	height _ sz // width.
	centerX _ width // 2.
	centerY _ height // 2.

	0 to: width - 1 do: [:x |
		0 to: height - 1 do: [:y |
			dx _ (x - centerX) / centerX asFloat.
			dy _ (y - centerY) / centerY asFloat.
			r _ ((dx * dx) + (dy * dy)) sqrt raisedTo: power.
			r <= 1.0
				ifTrue: [
					ang _ dy arcTan: dx.
					srcX _ centerX + ((r * ang cos) * centerX).
					srcY _ centerY + ((r * ang sin) * centerY)]
				ifFalse: [
					srcX _ x.
					srcY _ y].
			pix _ self primInterpolate: inForm bits width: inForm width x: (srcX * 1024) truncated y: (srcY * 1024) truncated.
			outForm bits at: ((y * width) + x + 1) put: pix]].

! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
fisheyeTest
	"self fisheyeTest"

	| f fOut |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	f display.
	100 to: 300 by: 10 do: [:power |
		self primFisheye: f bits into: fOut bits width: f width power: power.
		fOut display].
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
fisheyeTest2: power
	"self fisheyeTest2: 100"

	| f fOut |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	f display.
	self primFisheye: f bits into: fOut bits width: f width power: power.
	fOut display.
! !

!ScratchPlugin class methodsFor: 'translation' stamp: 'ikp 7/30/2012 14:38'!
hasHeaderFile

	^true! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
hueShiftTest
	"self hueShiftTest"

	| f fOut shift |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	[Sensor anyButtonPressed] whileFalse: [
		shift _ ((Sensor cursorPoint x - Display center x) * 380 * 2) // Display width.
		self primShiftHue: f bits into: fOut bits byDegrees: shift.
		fOut display].
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
interpolationTest: scale
	"Answer a copy of the given form scaled by the given factor using linear interpolation."
	"(self interpolationTest: 1.5) display"

	| scaleP srcForm outExtent fOut w h outW pix outH |
	scaleP _ scale asPoint.
	(scaleP x <= 0 or: [scaleP y <= 0]) ifTrue: [self error: 'bad scale factor'].
	srcForm _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	outExtent _ (srcForm extent * scaleP) truncated.
	(outExtent x > 1000 or: [outExtent y > 1000]) ifTrue: [self halt: 'result width or height will be > 1000 pixels'].
	fOut _ Form extent: outExtent depth: 32.
	w _ srcForm width.
	h _ srcForm height.
	outW _ fOut width.
	outH _ fOut height.
	0 to: fOut width - 1 do: [:x |
		0 to: fOut height - 1 do: [:y |
			pix _ self
				primInterpolate: srcForm bits
				width: srcForm width
				x: (x * w * 1024) // outW
				y:  (y * h * 1024) // outH.
			fOut bits at: ((y * outW) + x + 1) put: pix]].
	^ fOut
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 10/29/2007 10:30'!
isHidden: fullPath
	"Return true if file or folder with the given path should be hidden from the user. Return false if the primitive fails."
	"self isHidden: 'testfile.txt'"

	Smalltalk isMacOSX ifTrue: [^ false].
	((fullPath endsWith: ':\') and: [fullPath size = 3]) ifTrue: [^ false].

	^ self primIsHidden: fullPath
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/28/2005 11:11'!
isPortOpen: portNum
	"Answer true if the given serial port is open."
	"self isPortOpen: 1"

	<primitive: 'primIsPortOpen' module: 'ScratchPlugin'>
	^ false
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/31/2005 10:03'!
openPortNamed: portName baud: baudRate
	"Open the port with the given name at the given baud rate. Answer the port number to use for further operations on the given port or -1 if the port could not be opened."
	"self openPortNamed: '/dev/cu.USA19QW3b1P1.1' baud: 9600"

	<primitive: 'primOpenPortNamed' module: 'ScratchPlugin'>
	^ -1
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 1/23/2007 15:59'!
pluginAvailable
	"self pluginAvailable"

	| f r |
	f _ Form extent: 1@1 depth: 32.
	[r _ self primShiftHue: f bits into: f bits byDegrees: 180] ifError: [^ false].
	^ r notNil

! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/4/2005 17:24'!
portCount
	"Answer the number of serial ports. Answer 0 if there are no ports or if this primitive fails."
	"self portCount"

	<primitive: 'primPortCount' module: 'ScratchPlugin'>
	^ 0
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/26/2005 15:25'!
portCountOrNil
	"Answer the number of serial ports. Answer nil if this primitive fails."
	"self portCountOrNil"

	<primitive: 'primPortCount' module: 'ScratchPlugin'>
	^ nil
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/26/2005 15:47'!
portName: portIndex
	"Answer the name of the serial port with the given index. Answer nil if there is no port with the given index."
	"self portName: 1"

	<primitive: 'primPortName' module: 'ScratchPlugin'>
	^ nil
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 9/12/2005 16:56'!
port: portNum getOption: optionNum
	"Answer the value of the given serial port option, or nil if the port is not open or the option is not defined. See the class comment for the list of options."

	<primitive: 'primGetOption' module: 'ScratchPlugin'>
	^ nil
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 9/12/2005 16:57'!
port: portNum setOption: optionNum to: anInteger
	"Set the given serial port option to the given value. Do nothing if the option is not defined. See the class comment for the list of options."

	<primitive: 'primSetOption' module: 'ScratchPlugin'>
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primBlur: inBitmap into: outBitmap width: w
	"Blur all the non-transparent pixels in the given 32-bit image bitmap, storing the result in outBitmap. The two bitmaps must be the same size. Each call to this primitive does one Gausian blur step."

	<primitive: 'primitiveBlur' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'sound buffer utilities' stamp: 'jm 11/21/2006 21:12'!
primCondense: srcSoundBuffer into: dstSoundBuffer by: anInteger
	"Condense the given SoundBuffer by the given factor storing the rsult into the destination SoundBuffer."

	<primitive: 'primitiveCondenseSound' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primDouble: srcBitmap w: srcWidth h: srcHeight into: dstBitmap w: dstWidth h: dstHeight x: dstX y: dstY
	"Display the source form at double-size onto the destination form at the given location. Fails if the target rectangle does not fit entirely within the destination form."

	<primitive: 'primitiveDoubleSize' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'sound buffer utilities' stamp: 'jm 11/21/2006 20:33'!
primExtractChannelFrom: srcSoundBuffer into: dstSoundBuffer rightFlag: rightFlag
	"Extract the given channel of the source SoundBuffer in the destination SoundBuffer."

	<primitive: 'primitiveExtractChannel' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primFisheye: inBitmap into: outBitmap width: w power: anInteger
	"Do a fisheye lens transform of the given 32-bit image bitmap by the given power, storing the result in outBitmap. The two bitmaps must be the same size. Power is 0 for no change, > 0 for fisheye, < 0 for black hole effect."

	<primitive: 'primitiveFisheye' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 1/23/2007 15:46'!
primGetFolderPath: anInteger
	"Return the folder path for the given ID. Folder ID's are:
		1	home
		2	desktop
		3	documents
		4	my pictures
		5	my music.
	Return the path for the Scratch folder if the primitive fails."
	"self primGetFolderPath: 1"

	<primitive: 'primitiveGetFolderPath' module: 'ScratchPlugin'>
	^ FileDirectory default pathName
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 2/10/2008 11:58'!
primInterpolate: aBitmap width: w x: xFixed y: yFixed
	"Answer the interpolated pixel value from the given 32-bit bitmap with the given width. The coordinates are given as fixed-point integers with 10-bits of fraction. That is, the float values of x and y are multiplied by 1024, then truncated."

	<primitive: 'primitiveInterpolate' module: 'ScratchPlugin'>
	^ 0! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 6/22/2007 13:28'!
primIsHidden: fullPath
	"Return true if file or folder with the given path should be hidden from the user. Return false if the primitive fails."
	"self primIsHidden: 'testfile.txt'"

	<primitive: 'primitiveIsHidden' module: 'ScratchPlugin'>
	^ false
! !

!ScratchPlugin class methodsFor: 'primitive failure' stamp: 'jm 1/23/2007 15:53'!
primitiveFailed
	"Just beep rather than bringing up an error notifier."

	self beep.
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 1/23/2007 15:45'!
primOpenURL: aString
	"Open a browser window on the given URL. Do nothing if the primitive fails."
	"self primOpenURL: 'http://www.google.com'"

	<primitive: 'primitiveOpenURL' module: 'ScratchPlugin'>
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primScaleNoFail: srcBitmap w: srcWidth h: srcHeight into: dstBitmap w: dstWidth h: dstHeight
	"Scale the source form to exactly fit the destination form using bilinear interpolation. Answer nil if I fail."

	<primitive: 'primitiveScale' module: 'ScratchPlugin'>
	^ nil
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primScale: srcBitmap w: srcWidth h: srcHeight into: dstBitmap w: dstWidth h: dstHeight
	"Scale the source form to exactly fit the destination form using bilinear interpolation."

	<primitive: 'primitiveScale' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 10/5/2007 09:12'!
primSetUnicodePasteBuffer: aByteArray
	"Set the Mac OS X Unicode paste buffer. The argument is a big-endian UTF-16 Unicode string packed into a ByteArray. Needed to paste strings from Squeak into Second Life's code editor under Mac OS X. Do nothing if the primitive fails."
	"self primSetUnicodePasteBuffer: ByteArray new"

	<primitive: 'primitiveSetUnicodePasteBuffer' module: 'ScratchPlugin'>
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 1/23/2007 15:45'!
primSetWindowTitle: aString
	"Set the title of the Scratch window to the given string. Do nothing if the primitive fails."
	"self primSetWindowTitle: 'hello!!'"

	<primitive: 'primitiveSetWindowTitle' module: 'ScratchPlugin'>
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primShiftBrightness: inBitmap into: outBitmap by: shift
	"Shift the brightness of all the non-transparent pixels in the given 32-bit image bitmap, storing the result in outBitmap. The shift should be an integer between -100 and 100. The two bitmaps must be the same size."

	<primitive: 'primitiveBrightnessShift' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 1/23/2007 15:58'!
primShiftHue: inBitmap into: outBitmap byDegrees: shiftDegrees
	"Shift the hue of all the non-transparent, non-black pixels in the given 32-bit image bitmap, storing the result in outBitmap. The shift should be an integer between -360 and 360. The two bitmaps must be the same size."

	<primitive: 'primitiveHueShift' module: 'ScratchPlugin'>
	self primitiveFailed.
	^ nil

! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primShiftSaturation: inBitmap into: outBitmap by: shift
	"Shift the saturation of all the non-transparent, non-black pixels in the given 32-bit image bitmap, storing the result in outBitmap. The shift should be an integer between -100 and 100. The two bitmaps must be the same size."

	<primitive: 'primitiveSaturationShift' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 4/11/2007 09:02'!
primShortToLongPath: aString
	"Convert the given Windows short-filename path into a long-filename path. On other platforms this primitive will just return the input string."
	"self primShortToLongPath: 'hello!!'"

	<primitive: 'primitiveShortToLongPath' module: 'ScratchPlugin'>
	^ aString
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primWaterRipples1: inBitmap into: outBitmap width: w dropNum: aNum array1: aArray array2: bArray
	"Apply the water ripple effect to inBitmap putting the result into outBitmap. The two bitmaps must have the same length and are for 32-bit deep Forms of the given width. The dropNum determines how many new water drops are started. The two arrays hold the state of the water-surface model."

	<primitive: 'primitiveWaterRipples1' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'image filter primitives' stamp: 'jm 11/8/2006 10:58'!
primWhirl: inBitmap into: outBitmap width: w angle: anAngle
	"Whirl all the non-transparent pixels in the given 32-bit image bitmap by the given angle, storing the result in outBitmap. The two bitmaps must be the same size."

	<primitive: 'primitiveWhirl' module: 'ScratchPlugin'>
	self primitiveFailed
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/16/2005 15:57'!
readPort: portNum into: buffer
	"Read from the given port into the given ByteArray or String and answer the number of bytes read."
	"self readPort: 1 into: (ByteArray new: 10)"

	<primitive: 'primRead' module: 'ScratchPlugin'>
	^ 0
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
saturationShiftTest
	"self saturationShiftTest"

	| f fOut shift |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	[Sensor anyButtonPressed] whileFalse: [
		shift _ ((Sensor cursorPoint x - Display center x) * 220) // Display width.
		self primShiftSaturation: f bits into: fOut bits by: shift.
		fOut display].
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
scaleTest: scale
	"self scaleTest: 1.5"

	| f fOut |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ Form extent: (f extent * scale) rounded depth: 32.
	self primScale: f bits w: f width h: f height into: fOut bits w: fOut width h: fOut height.
	fOut display.

! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 11/8/2006 05:30'!
scale: aForm by: scale
	"Answer a 32-bit deep Form that's aForm scaled by the given factor. Scales using linear interpolation."

	| srcF scaledF r |
	srcF _ aForm asFormOfDepth: 32.
	srcF unhibernate.
	scaledF _ Form extent: (srcF extent * scale) rounded depth: 32.
	r _ self
		primScaleNoFail: srcF bits w: srcF width h: srcF height
		into: scaledF bits w: scaledF width h: scaledF height.
	r ifNil: [^ srcF magnify: srcF boundingBox by: scale asFloat smoothing: 1].
	^ scaledF
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 11/8/2006 19:45'!
serialPortOpsAvailable
	"Answer true if this plugin is available."
	"self serialPortOpsAvailable"
	"Smalltalk unloadPlugin: self name"

	^ self portCountOrNil notNil
! !

!ScratchPlugin class methodsFor: 'OS utilities' stamp: 'jm 9/2/2008 16:45'!
setUnicodePasteBuffer: aString
	"Set the Mac OS X Unicode paste buffer to the given Squeak string. Since the source is a Squeak string, there is no need to handle UTF-16 extended (4-byte) characters. However, we must take byte order into account to accomodate both Intel and PowerPC."
	"self setUnicodePasteBuffer: 'Hello, Unicode!!'"

	| utf32 s |
	utf32 _ aString asUTF32.
	s _ WriteStream on: (ByteArray new: 2 * aString size).
	Smalltalk isBigEndian
		ifTrue: [utf32 do: [:u | s nextPut: (u >> 8). s nextPut: (u bitAnd: 255)]]
		ifFalse: [utf32 do: [:u | s nextPut: (u bitAnd: 255). s nextPut: (u >> 8)]].

	self primSetUnicodePasteBuffer: s contents.
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
testFileName: aString
	"Set the name of an image file for testing."
	"self testFileName: 'hammy.jpg'"
	"self testFileName: 'JohnMugShotBW.jpg'"

	TestFileName _ aString.
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
waterRipples1ModuleTest
	"Smalltalk unloadPlugin: self name"
	"self waterRipples1ModuleTest"

	| f fOut ripply aArray bArray |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	aArray _ ByteArray new: (f width) * (f height) * 8 withAll: 0.
	bArray _ ByteArray new: (f width) * (f height) * 8 withAll: 0.

	[Sensor anyButtonPressed] whileFalse: [
		ripply _ Sensor cursorPoint x max: 1.
		ripply _ (((ripply / fOut width) sqrt) * 16.0) asInteger.
		ripply < 1 ifTrue: [ripply _ 1].
ripply printString display.
		self primWaterRipples1: f bits
			into: fOut bits
			width: f width
			dropNum: ripply
			array1: aArray
			array2: bArray.
		fOut displayAt: 10@30].
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
waterRipples1ModuleTest: n
	"Smalltalk unloadPlugin: self name"
	"self waterRipples1ModuleTest: 100"

	| f fOut aArray bArray |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	aArray _ ByteArray new: (f width * f height) * 8 withAll: 0.
	bArray _ ByteArray new: (f width * f height) * 8 withAll: 0.

	self primWaterRipples1: f bits
		into: fOut bits
		width: f width
		dropNum: n
		array1: aArray
		array2: bArray.
	[Sensor anyButtonPressed] whileFalse: [
		self primWaterRipples1: f bits
			into: fOut bits
			width: f width
			dropNum: 1
			array1: aArray
			array2: bArray.
		fOut displayAt: 10@30].
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
waterRipplesTime: n
	"Smalltalk unloadPlugin: self name"
	"self waterRipplesTime: 100"

	| f fOut aArray bArray |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	aArray _ ByteArray new: (f width * f height) * 8 withAll: 0.
	bArray _ ByteArray new: (f width * f height) * 8 withAll: 0.

	self primWaterRipples1: f bits
		into: fOut bits
		width: f width
		dropNum: n
		array1: aArray
		array2: bArray.

	^ [100 timesRepeat: [
		self primWaterRipples1: f bits
			into: fOut bits
			width: f width
			dropNum: 100
			array1: aArray
			array2: bArray]] msecs.
! !

!ScratchPlugin class methodsFor: 'image filters-testing' stamp: 'jm 11/8/2006 05:30'!
whirlTest
	"self whirlTest"

	| f fOut degrees |
	f _ (Form fromFileNamed: TestFileName) asFormOfDepth: 32.
	fOut _ f deepCopy.
	[Sensor anyButtonPressed] whileFalse: [
		degrees _ ((Sensor cursorPoint x - Display center x) * 450 * 2) // Display width.
		self primWhirl: f bits into: fOut bits width: f width angle: degrees.
		fOut display].
! !

!ScratchPlugin class methodsFor: 'serial port primitives' stamp: 'jm 8/16/2005 16:46'!
writePort: portNum data: buffer
	"Write data from the given ByteArray or String to the given port and answer the number of bytes written."
	"self writePort: 1 into: (ByteArray new: 10)"

	<primitive: 'primWrite' module: 'ScratchPlugin'>
	^ 0
! !

!ScratchPlugin methodsFor: 'private' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
bitmap: bitmap at: i putH: hue s: saturation v: brightness

	| hI hF p q t v outPix |
	<inline: true>
	<var: 'bitmap' declareC: 'unsigned int *bitmap'>

	hI := hue // 60.  "integer part of hue (0..5)"
	hF := hue \\ 60.  "fractional part ofhue"
	p := (1000 - saturation) * brightness.
	q := (1000 - ((saturation * hF) // 60)) * brightness.
	t := (1000 - ((saturation * (60 - hF)) // 60)) * brightness.

	v := (brightness * 1000) // 3922.
	p := p // 3922.
	q := q // 3922.
	t := t // 3922.

	0 = hI ifTrue: [outPix := ((v bitShift: 16) + (t bitShift: 8) + p)].
	1 = hI ifTrue: [outPix := ((q bitShift: 16) + (v bitShift: 8) + p)].
	2 = hI ifTrue: [outPix := ((p bitShift: 16) + (v bitShift: 8) + t)].
	3 = hI ifTrue: [outPix := ((p bitShift: 16) + (q bitShift: 8) + v)].
	4 = hI ifTrue: [outPix := ((t bitShift: 16) + (p bitShift: 8) + v)].
	5 = hI ifTrue: [outPix := ((v bitShift: 16) + (p bitShift: 8) + q)].

	outPix = 0 ifTrue: [outPix := 1].  "convert transparent to 1"
	bitmap at: i put: outPix.
	^ 0
! !

!ScratchPlugin methodsFor: 'private' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
checkedFloatPtrOf: oop
	"Return an unsigned int pointer to the first indexable word of oop, which must be a words object."

	<inline: true>
	<returnTypeC: 'double *'>

	interpreterProxy success: (interpreterProxy isWordsOrBytes: oop).
	interpreterProxy failed ifTrue: [^ 0].
	^ self cCoerce: (interpreterProxy firstIndexableField: oop) to: 'double *'
! !

!ScratchPlugin methodsFor: 'private' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
checkedUnsignedIntPtrOf: oop
	"Return an unsigned int pointer to the first indexable word of oop, which must be a words object."

	<inline: true>
	<returnTypeC: 'unsigned int *'>

	interpreterProxy success: (interpreterProxy isWords: oop).
	interpreterProxy failed ifTrue: [^ 0].
	^ self cCoerce: (interpreterProxy firstIndexableField: oop) to: 'unsigned int *'
! !

!ScratchPlugin methodsFor: 'private' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
hueFromR: r G: g B: b min: min max: max
	"Answer the hue, an angle between 0 and 360."

	| span result |
	<inline: true>

	span := max - min.
	span = 0 ifTrue: [^ 0].

	r = max
		ifTrue: [result := ((60 * (g - b)) // span)]
		ifFalse: [
			g = max
				ifTrue: [result := 120 + ((60 * (b - r)) // span)]
				ifFalse: [result := 240 + ((60 * (r - g)) // span)]].

	result < 0 ifTrue: [^ result + 360].
	^ result
! !

!ScratchPlugin methodsFor: 'private' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
interpolatedFrom: bitmap x: xFixed y: yFixed width: w height: h
	"Answer the interpolated pixel value from the given bitmap at the given point. The x and y coordinates are fixed-point integers with 10 bits of fraction (i.e. they were multiplied by 1024, then truncated). If the given point is right on an edge, answer the nearest edge pixel value. If it is entirely outside of the image, answer 0 (transparent)."

	| x y xFrac yFrac index topPix bottomPix |
	<inline: true>
	<var: 'bitmap' declareC: 'unsigned int *bitmap'>

	x := xFixed bitShift: -10.
	(x < -1 or: [x >= w]) ifTrue: [^ 0].
	y := yFixed bitShift: -10.
	(y < -1 or: [y >= h]) ifTrue: [^ 0].

	xFrac := xFixed bitAnd: 1023.
	x = -1 ifTrue: [x := 0. xFrac := 0].  "left edge"
	x = (w - 1) ifTrue: [xFrac := 0].  "right edge"

	yFrac := yFixed bitAnd: 1023.
	y = -1 ifTrue: [y := 0. yFrac := 0].  "top edge"
	y = (h - 1) ifTrue: [yFrac := 0].  "bottom edge"

	index := (y * w) + x "for squeak: + 1".
	topPix := (bitmap at: index) bitAnd: 16rFFFFFF.
	xFrac > 0 ifTrue: [
		topPix := self interpolate: topPix and: ((bitmap at: index + 1) bitAnd: 16rFFFFFF) frac: xFrac].

	yFrac = 0 ifTrue: [^ topPix].  "no y fraction, so just use value from top row"

	index := ((y + 1) * w) + x "for squeak: + 1".
	bottomPix := (bitmap at: index) bitAnd: 16rFFFFFF.
	xFrac > 0 ifTrue: [
		bottomPix := self interpolate: bottomPix and: ((bitmap at: index + 1) bitAnd: 16rFFFFFF) frac: xFrac].

	^ self interpolate: topPix and: bottomPix frac: yFrac
! !

!ScratchPlugin methodsFor: 'private' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
interpolate: pix1 and: pix2 frac: frac2
	"Answer the interpolated pixel value between the given two pixel values. If either pixel is zero (transparent) answer the other pixel. If both pixels are  transparent, answer transparent. The fraction is between 0 and 1023, out of a total range of 1024."

	| frac1 r g b result |
	<inline: true>

	pix1 = 0 ifTrue: [^ pix2].  "pix1 is transparent"
	pix2 = 0 ifTrue: [^ pix1].  "pix2 is transparent"

	frac1 := 1024 - frac2.
	r := ((frac1 * ((pix1 bitShift: -16) bitAnd: 16rFF)) + (frac2 * ((pix2 bitShift: -16) bitAnd: 16rFF))) // 1024.
	g := ((frac1 * ((pix1 bitShift: -8) bitAnd: 16rFF)) + (frac2 * ((pix2 bitShift: -8) bitAnd: 16rFF))) // 1024.
	b := ((frac1 * (pix1 bitAnd: 16rFF)) + (frac2 * (pix2 bitAnd: 16rFF))) // 1024.
	result := (r bitShift: 16) + (g bitShift: 8) + b.
	result = 0 ifTrue: [result := 1].
	^ result
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'jm (auto pragmas dtl 2014-01-04) 8/28/2005 10:57'!
primClose
	"Close the given serial port."

	| portNum |
	<export: true>
	portNum := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ nil].

	self cCode: 'SerialPortClose(portNum)'.

	interpreterProxy pop: 1.  "pop arg, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'jm (auto pragmas dtl 2014-01-04) 4/8/2007 14:50'!
primGetOption
	"Return the given option value for the given serial port."

	| portNum attrNum result |
	<export: true>
	portNum := interpreterProxy stackIntegerValue: 1.
	attrNum := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ nil].

	result := self cCode: 'SerialPortGetOption(portNum, attrNum)'.
	result = -1 ifTrue: [interpreterProxy success: false. ^ 0].

	interpreterProxy pop: 3.  "pop args and rcvr, push result"
	interpreterProxy pushInteger: result.
	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'jm (auto pragmas dtl 2014-01-04) 8/28/2005 10:57'!
primIsPortOpen
	"Answer the true if the given port is open."

	| portNum result |
	<export: true>
	portNum := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ 0].

	result := self cCode: 'SerialPortIsOpen(portNum)'.

	interpreterProxy pop: 2.  "pop arg and rcvr"
	interpreterProxy pushBool: result ~= 0.  "push result"
	^ 0
! !

!ScratchPlugin methodsFor: 'other filters' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveBlur

	| inOop outOop width in out sz height n rTotal gTotal bTotal pix outPix |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>
	<var: 'out' declareC: 'unsigned int *out'>

	inOop := interpreterProxy stackValue: 2.
	outOop := interpreterProxy stackValue: 1.
	width := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	sz := interpreterProxy stSizeOf: inOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = sz).
	interpreterProxy failed ifTrue: [^ nil].

	height := sz // width.
	1 to: height - 2 do: [:y |
		1 to: width - 2 do: [:x |
			n := rTotal := gTotal := bTotal := 0.
			-1 to: 1 do: [:dY |
				-1 to: 1 do: [:dX |
					pix := (in at: ((y + dY) * width) + (x + dX) "add 1 when testing in Squeak") bitAnd: 16rFFFFFF.
					pix = 0 ifFalse: [  "skip transparent pixels"
						rTotal := rTotal + ((pix bitShift: -16) bitAnd: 16rFF).
						gTotal := gTotal + ((pix bitShift: -8) bitAnd: 16rFF).
						bTotal := bTotal + (pix bitAnd: 16rFF).
						n := n + 1]]].
			n = 0
				ifTrue: [outPix :=  0]
				ifFalse: [outPix := ((rTotal // n) bitShift: 16) + ((gTotal // n) bitShift: 8) +  (bTotal // n)].
			out at: ((y * width) + x "add 1 when testing in Squeak") put: outPix]].

	interpreterProxy pop: 3.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'hsv filters' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveBrightnessShift

	| inOop outOop shift in sz out pix r g b max min hue saturation brightness |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>
	<var: 'out' declareC: 'unsigned int *out'>

	inOop := interpreterProxy stackValue: 2.
	outOop := interpreterProxy stackValue: 1.
	shift := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	sz := interpreterProxy stSizeOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = sz).
	interpreterProxy failed ifTrue: [^ nil].

	0 to: sz - 1 do: [:i |
		pix := (in at: i) bitAnd: 16rFFFFFF.
		pix = 0 ifFalse: [  "skip pixel values of 0 (transparent)"
			r := (pix bitShift: -16) bitAnd: 16rFF.
			g := (pix bitShift: -8) bitAnd: 16rFF.
			b := pix bitAnd: 16rFF.

			"find min and max color components"
			max := min := r.
			g > max ifTrue: [max := g].
			b > max ifTrue: [max := b].
			g < min ifTrue: [min := g].
			b < min ifTrue: [min := b].

			"find current hue with range 0 to 360"
			hue := self hueFromR: r G: g B: b min: min max: max.

			"find current saturation and brightness with range 0 to 1000"
			max = 0 ifTrue: [saturation := 0] ifFalse: [saturation := ((max - min) * 1000) // max].
			brightness := (max * 1000) // 255.

			"compute new brigthness"
			brightness := brightness + (shift * 10).
			brightness > 1000 ifTrue: [brightness := 1000].
			brightness < 0 ifTrue: [brightness := 0].

			self bitmap: out at: i putH: hue s: saturation v: brightness]].

	interpreterProxy pop: 3.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'sound' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/21/2006 21:21'!
primitiveCondenseSound

	| srcOop dstOop factor sz src dst count max v |
	<export: true>
	<var: 'src' declareC: 'short *src'>
	<var: 'dst' declareC: 'short *dst'>

	srcOop := interpreterProxy stackValue: 2.
	dstOop := interpreterProxy stackValue: 1.
	factor := interpreterProxy stackIntegerValue: 0.
	interpreterProxy success: (interpreterProxy isWords: srcOop).
	interpreterProxy success: (interpreterProxy isWords: dstOop).

	count := (2 * (interpreterProxy stSizeOf: srcOop)) // factor.
	sz := 2 * (interpreterProxy stSizeOf: dstOop).
	interpreterProxy success: (sz >= count).
	interpreterProxy failed ifTrue: [^ nil].

	src := self cCoerce: (interpreterProxy firstIndexableField: srcOop) to: 'short *'.
	dst := self cCoerce: (interpreterProxy firstIndexableField: dstOop) to: 'short *'.

	1 to: count do: [:i |
		max := 0.
		1 to: factor do: [:j |
			v := self cCode: '*src++'.
			v < 0 ifTrue: [v := 0 - v].
			v > max ifTrue: [max := v]].
		self cCode: '*dst++ = max'].

	interpreterProxy pop: 3.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'scaling' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveDoubleSize

	| in out inOop outOop inW inH outW outH dstX dstY baseIndex pix i |
	<export: true>
	<var: 'in' declareC: 'int *in'>
	<var: 'out' declareC: 'int *out'>

	inOop := interpreterProxy stackValue: 7.
	inW := interpreterProxy stackIntegerValue: 6.
	inH := interpreterProxy stackIntegerValue: 5.
	outOop := interpreterProxy stackValue: 4.
	outW := interpreterProxy stackIntegerValue: 3.
	outH := interpreterProxy stackIntegerValue: 2.
	dstX := interpreterProxy stackIntegerValue: 1.
	dstY := interpreterProxy stackIntegerValue: 0.

	in := self checkedUnsignedIntPtrOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	interpreterProxy success: (dstX + (2 * inW)) < outW.
	interpreterProxy success: (dstY + (2 * inH)) < outH.
	interpreterProxy failed ifTrue: [^ nil].

	0 to: inH - 1 do: [:y |
		baseIndex := ((dstY + (2 * y)) * outW) + dstX.
		0 to: inW - 1 do: [:x |
			pix := in at: x + (y * inW).
			i := baseIndex + (2 * x).
			out at: i put: pix.
			out at: i + 1 put: pix.
			out at: i + outW put: pix.
			out at: i + outW + 1 put: pix]].

	interpreterProxy pop: 8.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'sound' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/21/2006 20:53'!
primitiveExtractChannel

	| srcOop dstOop rightFlag sz src dst |
	<export: true>
	<var: 'src' declareC: 'short *src'>
	<var: 'dst' declareC: 'short *dst'>

	srcOop := interpreterProxy stackValue: 2.
	dstOop := interpreterProxy stackValue: 1.
	rightFlag := interpreterProxy booleanValueOf: (interpreterProxy stackValue: 0).
	interpreterProxy success: (interpreterProxy isWords: srcOop).
	interpreterProxy success: (interpreterProxy isWords: dstOop).

	sz := interpreterProxy stSizeOf: srcOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: dstOop) >= (sz // 2)).
	interpreterProxy failed ifTrue: [^ nil].

	src := self cCoerce: (interpreterProxy firstIndexableField: srcOop) to: 'short *'.
	dst := self cCoerce: (interpreterProxy firstIndexableField: dstOop) to: 'short *'.

	rightFlag ifTrue: [self cCode: 'src++']. 
	1 to: sz do: [:i | self cCode: '*dst++ = *src; src += 2'].

	interpreterProxy pop: 3.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'other filters' stamp: 'eem 1/30/2014 17:05'!
primitiveFisheye

	| inOop outOop width in out sz height centerX centerY dx dy ang pix power r srcX srcY scaledPower |
	<export: true>
	<var: 'in' type: #'unsigned int *'>
	<var: 'out' type: #'unsigned int *'>
	<var: 'dx' type: #double>
	<var: 'dy' type: #double>
	<var: 'ang' type: #double>
	<var: 'r' type: #double>
	<var: 'scaledPower' type: #double>

	inOop := interpreterProxy stackValue: 3.
	outOop := interpreterProxy stackValue: 2.
	width := interpreterProxy stackIntegerValue: 1.
	power := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	sz := interpreterProxy stSizeOf: inOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = sz).
	interpreterProxy failed ifTrue: [^ nil].

	"calculate height, center, scales, radius, whirlRadians, and radiusSquared"
	height := sz // width.
	centerX := width // 2.
	centerY := height // 2.

	height := sz // width.
	centerX := width // 2.
	centerY := height // 2.
	scaledPower := power / 100.0.

	0 to: width - 1 do: [:x |
		0 to: height - 1 do: [:y |
			dx := (x - centerX) / centerX asFloat.
			dy := (y - centerY) / centerY asFloat.
			r := ((dx * dx) + (dy * dy)) sqrt raisedTo: scaledPower.
			r <= 1.0
				ifTrue: [
					ang := self cCode: 'atan2(dy,dx)'.
					srcX := (1024 * (centerX + ((r * ang cos) * centerX))) asInteger.
					srcY := (1024 * (centerY + ((r * ang sin) * centerY))) asInteger]
				ifFalse: [
					srcX := 1024 * x.
					srcY := 1024 * y].
			pix := self interpolatedFrom: in
					x: srcX
					y: srcY
					width: width
					height: height.
			out at: ((y * width) + x "+ 1 for Squeak") put: pix]].

	interpreterProxy pop: 4.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'os functions' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 17:47'!
primitiveGetFolderPath
	"Get the path for the special folder with given ID. Fail if the folder ID is out of range."

	| nameStr dst folderID count resultOop |
	<export: true>
	<var: 'nameStr' declareC: 'char nameStr[2000]'>
	<var: 'dst' declareC: 'char* dst'>

	folderID := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ 0].

	self cCode: 'GetFolderPathForID(folderID, nameStr, 2000)'.

	count := self cCode: 'strlen(nameStr)'.
	resultOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: count.
	dst := self cCoerce: (interpreterProxy firstIndexableField: resultOop) to: 'char *'.
	0 to: count - 1 do: [:i | dst at: i put: (nameStr at: i)].

	interpreterProxy pop: 2 thenPush: resultOop.  "pop arg and rcvr, push result"
	^ 0
! !

!ScratchPlugin methodsFor: 'scaling' stamp: 'jm (auto pragmas dtl 2014-01-04) 1/1/2009 17:08'!
primitiveHalfSizeAverage

	| in inW inH out outW outH srcX srcY dstX dstY dstW dstH srcIndex dstIndex pixel r g b |
	<export: true>
	<var: 'in' declareC: 'int *in'>
	<var: 'out' declareC: 'int *out'>

	in := self checkedUnsignedIntPtrOf: (interpreterProxy stackValue: 11).
	inW := interpreterProxy stackIntegerValue: 10.
	inH := interpreterProxy stackIntegerValue: 9.
	out := self checkedUnsignedIntPtrOf: (interpreterProxy stackValue: 8).
	outW := interpreterProxy stackIntegerValue: 7.
	outH := interpreterProxy stackIntegerValue: 6.
	srcX := interpreterProxy stackIntegerValue: 5.
	srcY := interpreterProxy stackIntegerValue: 4.
	dstX := interpreterProxy stackIntegerValue: 3.
	dstY := interpreterProxy stackIntegerValue: 2.
	dstW := interpreterProxy stackIntegerValue: 1.
	dstH := interpreterProxy stackIntegerValue: 0.

	interpreterProxy success: (srcX >= 0) & (srcY >= 0).
	interpreterProxy success: (srcX + (2 * dstW)) <= inW.
	interpreterProxy success: (srcY + (2 * dstH)) <= inH.
	interpreterProxy success: (dstX >= 0) & (dstY >= 0).
	interpreterProxy success: (dstX + dstW) <= outW.
	interpreterProxy success: (dstY + dstH) <= outH.
	interpreterProxy failed ifTrue: [^ nil].

	0 to: dstH - 1 do: [:y |
		srcIndex := (inW * (srcY + (2 * y))) + srcX.
		dstIndex := (outW * (dstY + y)) + dstX.
		0 to: dstW - 1 do: [:x |
			pixel := in at: srcIndex.
			r := pixel bitAnd: 16rFF0000.
			g := pixel bitAnd: 16rFF00.
			b := pixel bitAnd: 16rFF.

			pixel := in at: srcIndex + 1.
			r := r + (pixel bitAnd: 16rFF0000).
			g := g + (pixel bitAnd: 16rFF00).
			b := b + (pixel bitAnd: 16rFF).

			pixel := in at: srcIndex + inW.
			r := r + (pixel bitAnd: 16rFF0000).
			g := g + (pixel bitAnd: 16rFF00).
			b := b + (pixel bitAnd: 16rFF).

			pixel := in at: srcIndex + inW + 1.
			r := r + (pixel bitAnd: 16rFF0000).
			g := g + (pixel bitAnd: 16rFF00).
			b := b + (pixel bitAnd: 16rFF).

			"store combined RGB into target bitmap"
			out at: dstIndex put:
				(((r bitShift: -2) bitAnd: 16rFF0000) bitOr:
				(((g bitShift: -2) bitAnd: 16rFF00) bitOr: (b bitShift: -2))).

			srcIndex := srcIndex + 2.
			dstIndex := dstIndex + 1]].

	interpreterProxy pop: 12.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'scaling' stamp: 'jm (auto pragmas dtl 2014-01-04) 1/1/2009 17:08'!
primitiveHalfSizeDiagonal

	| in inW inH out outW outH srcX srcY dstX dstY dstW dstH srcIndex dstIndex p1 p2 r g b |
	<export: true>
	<var: 'in' declareC: 'int *in'>
	<var: 'out' declareC: 'int *out'>

	in := self checkedUnsignedIntPtrOf: (interpreterProxy stackValue: 11).
	inW := interpreterProxy stackIntegerValue: 10.
	inH := interpreterProxy stackIntegerValue: 9.
	out := self checkedUnsignedIntPtrOf: (interpreterProxy stackValue: 8).
	outW := interpreterProxy stackIntegerValue: 7.
	outH := interpreterProxy stackIntegerValue: 6.
	srcX := interpreterProxy stackIntegerValue: 5.
	srcY := interpreterProxy stackIntegerValue: 4.
	dstX := interpreterProxy stackIntegerValue: 3.
	dstY := interpreterProxy stackIntegerValue: 2.
	dstW := interpreterProxy stackIntegerValue: 1.
	dstH := interpreterProxy stackIntegerValue: 0.

	interpreterProxy success: (srcX >= 0) & (srcY >= 0).
	interpreterProxy success: (srcX + (2 * dstW)) <= inW.
	interpreterProxy success: (srcY + (2 * dstH)) <= inH.
	interpreterProxy success: (dstX >= 0) & (dstY >= 0).
	interpreterProxy success: (dstX + dstW) <= outW.
	interpreterProxy success: (dstY + dstH) <= outH.
	interpreterProxy failed ifTrue: [^ nil].

	0 to: dstH - 1 do: [:y |
		srcIndex := (inW * (srcY + (2 * y))) + srcX.
		dstIndex := (outW * (dstY + y)) + dstX.
		0 to: dstW - 1 do: [:x |
			p1 := in at: srcIndex.
			p2 := in at: srcIndex + inW + 1.

			r := (((p1 bitAnd: 16rFF0000) + (p2 bitAnd: 16rFF0000)) bitShift: -1) bitAnd: 16rFF0000.
			g := (((p1 bitAnd: 16rFF00) + (p2 bitAnd: 16rFF00)) bitShift: -1) bitAnd: 16rFF00.
			b := ((p1 bitAnd: 16rFF) + (p2 bitAnd: 16rFF)) bitShift: -1.

			"store combined RGB into target bitmap"
			out at: dstIndex put: (r bitOr: (g bitOr: b)).

			srcIndex := srcIndex + 2.
			dstIndex := dstIndex + 1]].

	interpreterProxy pop: 12.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'hsv filters' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveHueShift

	| inOop outOop shift in sz out pix r g b max min brightness saturation hue |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>
	<var: 'out' declareC: 'unsigned int *out'>

	inOop := interpreterProxy stackValue: 2.
	outOop := interpreterProxy stackValue: 1.
	shift := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	sz := interpreterProxy stSizeOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = sz).
	interpreterProxy failed ifTrue: [^ nil].

	0 to: sz - 1 do: [:i |
		pix := (in at: i) bitAnd: 16rFFFFFF.
		pix = 0 ifFalse: [  "skip pixel values of 0 (transparent)"
			r := (pix bitShift: -16) bitAnd: 16rFF.
			g := (pix bitShift: -8) bitAnd: 16rFF.
			b := pix bitAnd: 16rFF.

			"find min and max color components"
			max := min := r.
			g > max ifTrue: [max := g].
			b > max ifTrue: [max := b].
			g < min ifTrue: [min := g].
			b < min ifTrue: [min := b].

			"find current brightness (v) and  saturation with range 0 to 1000"
			brightness := (max * 1000) // 255.
			max = 0 ifTrue: [saturation := 0] ifFalse: [saturation := ((max - min) * 1000) // max].

			brightness < 110 ifTrue: [					"force black to a very dark, saturated gray"
				brightness := 110. saturation := 1000].	
			saturation < 90 ifTrue: [saturation := 90].		"force a small color change on grays"
			((brightness = 110) | (saturation = 90))		"tint all blacks and grays the same"
				ifTrue: [hue := 0]
				ifFalse: [hue := self hueFromR: r G: g B: b min: min max: max].

			hue := (hue + shift + 360000000) \\ 360.  "compute new hue"
			self bitmap: out at: i putH: hue s: saturation v: brightness]].

	interpreterProxy pop: 3.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'bilinear interpolation' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveInterpolate

	| inOop xFixed yFixed width in sz result |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>

	inOop := interpreterProxy stackValue: 3.
	width := interpreterProxy stackIntegerValue: 2.
	xFixed := interpreterProxy stackIntegerValue: 1.
	yFixed := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	sz := interpreterProxy stSizeOf: inOop.
	interpreterProxy failed ifTrue: [^ nil].

	result := self interpolatedFrom: in x: xFixed y: yFixed width: width height: sz // width.

	interpreterProxy pop: 5.  "pop args and rcvr"
	interpreterProxy pushInteger: result.
	^ 0
! !

!ScratchPlugin methodsFor: 'os functions' stamp: 'eem 1/30/2014 15:19'!
primitiveIsHidden
	"Answer true if the file or folder with the given path should be hidden from the user. On Windows, this is the value of the 'hidden' file property."

	| pathOop src count fullPath result |
	<export: true>
	<var: 'fullPath' declareC: 'char fullPath[1000]'>
	<var: 'src' type: #'char *'>

	pathOop := interpreterProxy stackValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: pathOop).

	interpreterProxy failed ifTrue: [^ 0].

	src := self cCoerce: (interpreterProxy firstIndexableField: pathOop) to: #'char *'.
	count := interpreterProxy stSizeOf: pathOop.
	count >= 1000 ifTrue: [interpreterProxy success: false. ^ 0].
	0 to: count - 1 do: [:i | fullPath at: i put: (src at: i)].
	fullPath at: count put: 0.

	result := self IsFileOrFolderHidden: fullPath.

	interpreterProxy pop: 2.  "pop arg and rcvr"
	interpreterProxy pushBool: result ~= 0.  "push result"
	^ 0! !

!ScratchPlugin methodsFor: 'os functions' stamp: 'eem 1/30/2014 15:19'!
primitiveOpenURL
	"Open a web browser on the given URL."

	| urlStr src urlOop count |
	<export: true>
	<var: 'urlStr' declareC: 'char urlStr[2000]'>
	<var: 'src' type: #'char *'>

	urlOop := interpreterProxy stackValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: urlOop).

	interpreterProxy failed ifTrue: [^ 0].

	src := self cCoerce: (interpreterProxy firstIndexableField: urlOop) to: #'char *'.
	count := interpreterProxy stSizeOf: urlOop.
	count >= 2000 ifTrue: [interpreterProxy success: false. ^ 0].
	0 to: count - 1 do: [:i | urlStr at: i put: (src at: i)].
	urlStr at: count put: 0.

	self OpenURL: urlStr.

	interpreterProxy pop: 1.  "pop arg, leave rcvr on stack"
	^ 0! !

!ScratchPlugin methodsFor: 'hsv filters' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveSaturationShift

	| inOop outOop shift in sz out pix r g b max min brightness saturation hue |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>
	<var: 'out' declareC: 'unsigned int *out'>

	inOop := interpreterProxy stackValue: 2.
	outOop := interpreterProxy stackValue: 1.
	shift := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	sz := interpreterProxy stSizeOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = sz).
	interpreterProxy failed ifTrue: [^ nil].

	0 to: sz - 1 do: [:i |
		pix := (in at: i) bitAnd: 16rFFFFFF.
		pix < 2 ifFalse: [  "skip pixel values of 0 (transparent) and 1 (black)"
			r := (pix bitShift: -16) bitAnd: 16rFF.
			g := (pix bitShift: -8) bitAnd: 16rFF.
			b := pix bitAnd: 16rFF.

			"find min and max color components"
			max := min := r.
			g > max ifTrue: [max := g].
			b > max ifTrue: [max := b].
			g < min ifTrue: [min := g].
			b < min ifTrue: [min := b].

			"find current brightness (v) and  saturation with range 0 to 1000"
			brightness := (max * 1000) // 255.
			max = 0 ifTrue: [saturation := 0] ifFalse: [saturation := ((max - min) * 1000) // max].

			saturation > 0 ifTrue: [  "do nothing if pixel is unsaturated (gray)"
				hue := self hueFromR: r G: g B: b min: min max: max.

				"compute new saturation"
				saturation := saturation + (shift * 10).
				saturation > 1000 ifTrue: [saturation := 1000].
				saturation < 0 ifTrue: [saturation := 0].
				self bitmap: out at: i putH: hue s: saturation v: brightness]]].

	interpreterProxy pop: 3.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'scaling' stamp: 'tpr 12/10/2014 13:09'!
primitiveScale
	"Scale using bilinear interpolation."
	"This version isn't really able to do much with full ARGB based images; the A channel will be ignored and only fully transparent pixels will be treated as transparent. The output pixel will be either fully transparent or fully opaque."

	| inOop inW inH outOop outW outH in out inX inY xIncr yIncr outPix w1 w2 w3 w4 t p1 p2 p3 p4 tWeight |
	<export: true>
	<var: 'in' declareC: 'int *in'>
	<var: 'out' declareC: 'int *out'>

	inOop := interpreterProxy stackValue: 5.
	inW := interpreterProxy stackIntegerValue: 4.
	inH := interpreterProxy stackIntegerValue: 3.
	outOop := interpreterProxy stackValue: 2.
	outW := interpreterProxy stackIntegerValue: 1.
	outH := interpreterProxy stackIntegerValue: 0.

	interpreterProxy success: (interpreterProxy stSizeOf: inOop) = (inW * inH).
	interpreterProxy success: (interpreterProxy stSizeOf: outOop) = (outW * outH).
	in := self checkedUnsignedIntPtrOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	interpreterProxy failed ifTrue: [^ nil].

	inX := inY := 0.					"source x and y, scaled by 1024"
	xIncr := (inW * 1024) // outW.	"source x increment, scaled by 1024"
	yIncr := (inH * 1024) // outH.		"source y increment, scaled by 1024"

	0 to: (outH - 1) do: [:outY |
		inX := 0.
		0 to: (outW - 1) do: [:outX |
			"compute weights, scaled by 2^20"
			w1 := (1024 - (inX bitAnd: 1023))	* (1024 - (inY bitAnd: 1023)).
			w2 := (inX bitAnd: 1023)			* (1024 - (inY bitAnd: 1023)).
			w3 := (1024 - (inX bitAnd: 1023))	* (inY bitAnd: 1023).
			w4 := (inX bitAnd: 1023)			* (inY bitAnd: 1023).

			"get source pixels"
			t := ((inY >> 10) * inW) + (inX >> 10).
			p1 := in at: t.
			((inX >> 10) < (inW - 1)) ifTrue: [p2 := in at: t + 1] ifFalse: [p2 := p1].
			(inY >> 10) < (inH - 1) ifTrue: [t := t + inW].  "next row"
			p3 := in at: t.
			((inX >> 10) < (inW - 1)) ifTrue: [p4 := in at: t + 1] ifFalse: [p4 := p3].

			"deal with transparent pixels"
			"Note as above - only transparent not translucent"
			tWeight := 0.
			p1 = 0 ifTrue: [p1 := p2. tWeight := tWeight + w1].
			p2 = 0 ifTrue: [p2 := p1. tWeight := tWeight + w2].
			p3 = 0 ifTrue: [p3 := p4. tWeight := tWeight + w3].
			p4 = 0 ifTrue: [p4 := p3. tWeight := tWeight + w4].
			p1 = 0 ifTrue: [p1 := p3. p2 := p4].  "both top pixels were transparent; use bottom row"
			p3 = 0 ifTrue: [p3 := p1. p4 := p2].  "both bottom pixels were transparent; use top row"

			outPix := 0.
			tWeight < 500000 ifTrue: [  "compute an (opaque) output pixel if less than 50% transparent"
				t := (w1 * ((p1 >> 16) bitAnd: 255)) + (w2 * ((p2 >> 16) bitAnd: 255)) + (w3 * ((p3 >> 16) bitAnd: 255)) + (w4 * ((p4 >> 16) bitAnd: 255)).
				outPix := ((t >> 20) bitAnd: 255) << 16.
				t := (w1 * ((p1 >> 8) bitAnd: 255)) + (w2 * ((p2 >> 8) bitAnd: 255)) + (w3 * ((p3 >> 8) bitAnd: 255)) + (w4 * ((p4 >> 8) bitAnd: 255)).
				outPix := outPix bitOr: (((t >> 20) bitAnd: 255) << 8).
				t := (w1 * (p1 bitAnd: 255)) + (w2 * (p2 bitAnd: 255)) + (w3 * (p3 bitAnd: 255)) + (w4 * (p4 bitAnd: 255)).
				outPix := outPix bitOr: ((t >> 20) bitAnd: 255).
				"If the result is black, remember to make it Squeak-standard-fake-black"
				outPix = 0 ifTrue: [outPix := 1].
				"add the A channel to make it really opaque"
				outPix := outPix bitOr: 16rFF000000].

			out at: (outY * outW) + outX put: outPix.
			inX := inX + xIncr].
		inY := inY + yIncr].

	interpreterProxy pop: 6.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'os functions' stamp: 'eem 1/30/2014 15:19'!
primitiveSetUnicodePasteBuffer
	"Set the Mac OS X Unicode paste buffer."

	| utf16 strOop count |
	<export: true>
	<var: 'utf16' declareC: 'short *utf16'>

	strOop := interpreterProxy stackValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: strOop).

	interpreterProxy failed ifTrue: [^ 0].

	utf16 := self cCoerce: (interpreterProxy firstIndexableField: strOop) to: #'short *'.
	count := interpreterProxy stSizeOf: strOop.

	self SetUnicodePaste: utf16 Buffer: count.

	interpreterProxy pop: 1.  "pop arg, leave rcvr on stack"
	^ 0! !

!ScratchPlugin methodsFor: 'os functions' stamp: 'eem 1/30/2014 15:19'!
primitiveSetWindowTitle
	"Set the title of the Scratch window."

	| titleStr src titleOop count |
	<export: true>
	<var: 'titleStr' declareC: 'char titleStr[1000]'>
	<var: 'src' type: #'char *'>

	titleOop := interpreterProxy stackValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: titleOop).

	interpreterProxy failed ifTrue: [^ 0].

	src := self cCoerce: (interpreterProxy firstIndexableField: titleOop) to: #'char *'.
	count := interpreterProxy stSizeOf: titleOop.
	count >= 1000 ifTrue: [interpreterProxy success: false. ^ 0].
	0 to: count - 1 do: [:i | titleStr at: i put: (src at: i)].
	titleStr at: count put: 0.

	self SetScratchWindowTitle: titleStr.

	interpreterProxy pop: 1.  "pop arg, leave rcvr on stack"
	^ 0! !

!ScratchPlugin methodsFor: 'os functions' stamp: 'eem 1/30/2014 15:19'!
primitiveShortToLongPath
	"On Windows, convert a short file/path name into a long one. Fail on other platforms."

	| shortPath longPath ptr shortPathOop result count resultOop |
	<export: true>
	<var: 'shortPath' declareC: 'char shortPath[1000]'>
	<var: 'longPath' declareC: 'char longPath[1000]'>
	<var: 'ptr' type: #'char *'>

	shortPathOop := interpreterProxy stackValue: 0.

	(interpreterProxy isBytes: shortPathOop) ifFalse:
		[interpreterProxy success: false. ^ 0].

	ptr := self cCoerce: (interpreterProxy firstIndexableField: shortPathOop) to: #'char *'.
	count := interpreterProxy stSizeOf: shortPathOop.
	count >= 1000 ifTrue: [interpreterProxy success: false. ^ 0].
	0 to: count - 1 do: [:i | shortPath at: i put: (ptr at: i)].
	shortPath at: count put: 0.

	result := self cCode: 'WinShortToLongPath(shortPath, longPath, 1000)'.
	result = -1 ifTrue: [interpreterProxy success: false. ^ 0].

	count := self strlen: longPath.
	resultOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: count.
	ptr := self cCoerce: (interpreterProxy firstIndexableField: resultOop) to: #'char *'.
	0 to: count - 1 do: [:i | ptr at: i put: (longPath at: i)].

	interpreterProxy pop: 2 thenPush: resultOop.  "pop arg and rcvr, push result"
	^ 0! !

!ScratchPlugin methodsFor: 'other filters' stamp: 'eem 1/6/2014 18:39'!
primitiveWaterRipples1
 
	| in out aArray bArray ripply temp pix dx dy dist inOop outOop width allPix aArOop bArOop height t1 blops x y power val val2 dx2 dy2 newLoc |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>
	<var: 'out' declareC: 'unsigned int *out'>
	<var: 'aArray' declareC: 'double *aArray'>
	<var: 'bArray' declareC: 'double *bArray'>
	<var: 'ripply' declareC: 'int ripply'>
	<var: 'temp' declareC: 'double temp'>
	<var: 'pix' declareC: 'unsigned int pix'>
	<var: 'dist' declareC: 'double dist'>
	<var: 'dx2' declareC: 'double dx2'>
	<var: 'dy2' declareC: 'double dy2'>

	inOop := interpreterProxy stackValue: 5.
	outOop := interpreterProxy stackValue: 4.
	width := interpreterProxy stackIntegerValue: 3.
	in := self checkedUnsignedIntPtrOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	allPix := interpreterProxy stSizeOf: inOop.
	ripply := interpreterProxy stackIntegerValue: 2.
	aArOop := interpreterProxy stackValue: 1.
	bArOop := interpreterProxy stackValue: 0.
	aArray := self checkedFloatPtrOf: aArOop.
	bArray := self checkedFloatPtrOf: bArOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = allPix).
	interpreterProxy failed ifTrue: [^ nil].

	height := allPix // width.

	t1 := self cCode: 'rand()'.
	blops := t1 \\ ripply -1.
	0 to: blops /2-1 do: [:t |
		t1 := self cCode: 'rand()'.
		x := t1 \\ width.
		t1 := self cCode: 'rand()'.
		y := t1 \\ height.
		t1 := self cCode: 'rand()'.
		power := t1 \\ 8.
		-4 to: 4 do: [:g |
			-4 to: 4 do: [:h |
				dist := ((g*g) + (h*h)) asFloat.
				((dist < 25) and: [dist > 0]) ifTrue: [
						dx := (x + g) asInteger.
						dy := (y + h) asInteger.
						((dx >0) and: [(dy>0) and: [(dy < height) and: [dx < width]]]) ifTrue: [
							aArray at: ((dy)*width + dx) put: (power *(1.0 asFloat -(dist/(25.0 asFloat))) asFloat).
						].
					].
				].
			].
		].
	
		1 to: width -2 do: [:f |
			1 to: height -2 do: [:d |
			val := (d)*width + f.
			aArray at: val put: (((
				(bArray at: (val+1)) + (bArray at: (val-1)) + (bArray at: (val + width)) + (bArray at: (val - width)) +
				((bArray at: (val -1 -width))/2) + ((bArray at: (val-1+width))/2) + ((bArray at: (val+1-width))/2) + ((bArray at: (val+1+width))/2)) /4) - (aArray at: (val))).
			aArray at: (val) put: ((aArray at: (val))*(0.9 asFloat)).
			].
		].
	
		"temp := bArray.
		bArray := aArray.
		aArray := temp."
		0 to: width*height do: [:q |
			temp := bArray at: q.
			bArray at: q put: (aArray at: q).
			aArray at: q put: temp.
		].

		0 to: height-1 do: [:j |
			0 to: width-1 do: [:i |
				((i > 1) and: [(i<(width-1)) and: [(j>1) and: [(j<(height-1))]]]) ifTrue: [
					val2 := (j)*width + i.
					dx2 := ((((aArray at: (val2)) - (aArray at: (val2-1))) + ((aArray at: (val2+1)) - (aArray at: (val2)))) *64) asFloat.
					dy2 := ((((aArray at: (val2)) - (aArray at: (val2-width))) + ((aArray at: (val2+width)) - (aArray at: (val2)))) /64) asFloat.
					(dx2 < -2) ifTrue: [dx2 := -2].
					(dx2 >  2) ifTrue: [dx2 :=  2].
					(dy2 < -2) ifTrue: [dy2 := -2].
					(dy2 >  2) ifTrue: [dy2 :=  2].
					newLoc := ((j+dy2)*width + (i+dx2)) asInteger.
					((newLoc < (width*height)) and: [newLoc >=0]) ifTrue: [
						pix := in at: newLoc]
					ifFalse: [
						pix := in at: (i +(j*width)) ].
				]
				ifFalse: [
					pix := in at: (i +(j*width)) ].
			out at: (i + (j*width)) put: pix.
		]].

	interpreterProxy pop: 6.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'other filters' stamp: 'jm (auto pragmas dtl 2014-01-04) 11/8/2006 05:30'!
primitiveWhirl

	| inOop outOop width degrees in out sz height centerX centerY radius scaleX scaleY whirlRadians radiusSquared dx dy d factor ang sina cosa pix |
	<export: true>
	<var: 'in' declareC: 'unsigned int *in'>
	<var: 'out' declareC: 'unsigned int *out'>
	<var: 'scaleX' declareC: 'double scaleX'>
	<var: 'scaleY' declareC: 'double scaleY'>
	<var: 'whirlRadians' declareC: 'double whirlRadians'>
	<var: 'radiusSquared' declareC: 'double radiusSquared'>
	<var: 'dx' declareC: 'double dx'>
	<var: 'dy' declareC: 'double dy'>
	<var: 'd' declareC: 'double d'>
	<var: 'factor' declareC: 'double factor'>
	<var: 'ang' declareC: 'double ang'>
	<var: 'sina' declareC: 'double sina'>
	<var: 'cosa' declareC: 'double cosa'>

	inOop := interpreterProxy stackValue: 3.
	outOop := interpreterProxy stackValue: 2.
	width := interpreterProxy stackIntegerValue: 1.
	degrees := interpreterProxy stackIntegerValue: 0.
	in := self checkedUnsignedIntPtrOf: inOop.
	out := self checkedUnsignedIntPtrOf: outOop.
	sz := interpreterProxy stSizeOf: inOop.
	interpreterProxy success: ((interpreterProxy stSizeOf: outOop) = sz).
	interpreterProxy failed ifTrue: [^ nil].

	"calculate height, center, scales, radius, whirlRadians, and radiusSquared"
	height := sz // width.
	centerX := width // 2.
	centerY := height // 2.
	centerX < centerY
		ifTrue: [
			radius := centerX.
			scaleX := centerY asFloat / centerX. 
			scaleY := 1.0]
		ifFalse: [
			radius := centerY.
			scaleX := 1.0.
			centerY < centerX
				ifTrue: [scaleY := centerX asFloat / centerY]
				ifFalse: [scaleY := 1.0]].
	whirlRadians := (-3.141592653589793 * degrees) / 180.0.
	radiusSquared := (radius * radius) asFloat.

	0 to: width - 1 do: [:x |
		0 to: height - 1 do: [:y |
			dx := scaleX * (x - centerX) asFloat.
			dy := scaleY * (y - centerY) asFloat.
			d := (dx * dx) + (dy * dy).
			d < radiusSquared ifTrue: [  "inside the whirl circle"
				factor := 1.0 - (d sqrt / radius).
				ang := whirlRadians * (factor * factor).
				sina := ang sin.
				cosa := ang cos.
				pix := self interpolatedFrom: in
					x: (1024.0 * ((((cosa * dx) - (sina * dy)) / scaleX) + centerX)) asInteger
					y: (1024.0 * ((((sina * dx) + (cosa * dy)) / scaleY) + centerY)) asInteger
					width: width
					height: height.
				out at: ((width * y) + x "for Squeak: + 1") put: pix]]].

	interpreterProxy pop: 4.  "pop args, leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'eem 1/30/2014 15:26'!
primOpenPortNamed
	"Open the port with the given name and baud rate."

	| nameStr src nameOop baudRate count portNum |
	<export: true>
	<var: 'nameStr' declareC: 'char nameStr[1000]'>
	<var: 'src' type: #'char *'>

	nameOop := interpreterProxy stackValue: 1.
	baudRate := interpreterProxy stackIntegerValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: nameOop).

	interpreterProxy failed ifTrue: [^ 0].

	src := self cCoerce: (interpreterProxy firstIndexableField: nameOop) to: #'char *'.
	count := interpreterProxy stSizeOf: nameOop.
	0 to: count - 1 do: [:i | nameStr at: i put: (src at: i)].
	nameStr at: count put: 0.

	portNum := self SerialPortOpen: nameStr PortNamed: baudRate.
	portNum = -1 ifTrue: [interpreterProxy success: false. ^ 0].

	interpreterProxy	"pop args and rcvr, push result"
		pop: 3
		thenPush: (interpreterProxy integerObjectOf: portNum).

	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'jm (auto pragmas dtl 2014-01-04) 4/8/2007 14:52'!
primPortCount
	"Answer the number of serial ports."

	| result |
	<export: true>

	result := self cCode: 'SerialPortCount()'.
	result = -1 ifTrue: [interpreterProxy success: false. ^ 0].

	interpreterProxy
		pop: 1 thenPush: (interpreterProxy integerObjectOf: result).  "pop rcvr, push result"
	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'jm (auto pragmas dtl 2014-01-04) 8/28/2005 11:02'!
primPortName
	"Get the name for the port with the given number. Fail if the port number is greater than the number of available ports. Port numbering starts with 1."

	| portIndex nameStr count resultOop dst |
	<export: true>
	<var: 'nameStr' declareC: 'char nameStr[1000]'>
	<var: 'dst' declareC: 'char* dst'>

	portIndex := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ 0].

	self cCode: 'SerialPortName(portIndex, nameStr, 1000)'.

	count := self cCode: 'strlen(nameStr)'.
	count = 0 ifTrue: [
		interpreterProxy success: false.
		^ 0].

	resultOop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: count.
	dst := self cCoerce: (interpreterProxy firstIndexableField: resultOop) to: 'char *'.
	0 to: count - 1 do: [:i | dst at: i put: (nameStr at: i)].

	interpreterProxy pop: 2 thenPush: resultOop.  "pop arg and rcvr, push result"
	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'eem 1/30/2014 15:24'!
primRead
	"Read data from the given serial port into the given buffer (a ByteArray or String). Answer the number of bytes read."

	| portNum bufOop bytesRead |
	<export: true>

	portNum := interpreterProxy stackIntegerValue: 1.
	bufOop := interpreterProxy stackValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: bufOop).
	interpreterProxy failed ifTrue: [^ 0].

	bytesRead := self Serial: portNum
						Port: (self cCoerce: (interpreterProxy firstIndexableField: bufOop) to: 'char *')
						Read: (interpreterProxy stSizeOf: bufOop).

	interpreterProxy pop: 3.  					"pop args and rcvr"
	interpreterProxy pushInteger: bytesRead.	"push result"
	^ 0! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'jm (auto pragmas dtl 2014-01-04) 4/8/2007 14:55'!
primSetOption
	"Return the given option value for the given serial port."

	| portNum attrNum attrValue result |
	<export: true>
	portNum := interpreterProxy stackIntegerValue: 2.
	attrNum := interpreterProxy stackIntegerValue: 1.
	attrValue := interpreterProxy stackIntegerValue: 0.
	interpreterProxy failed ifTrue: [^ nil].

	result := self cCode: 'SerialPortSetOption(portNum, attrNum, attrValue)'.
	result = -1 ifTrue: [interpreterProxy success: false. ^ 0].

	interpreterProxy pop: 3.  "pop args; leave rcvr on stack"
	^ 0
! !

!ScratchPlugin methodsFor: 'serial port' stamp: 'eem 1/30/2014 15:25'!
primWrite
	"Write data to the given serial port from the given buffer (a ByteArray or String). Answer the number of bytes written."

	| portNum bufOop bytesWritten |
	<export: true>

	portNum := interpreterProxy stackIntegerValue: 1.
	bufOop := interpreterProxy stackValue: 0.

	interpreterProxy success: (interpreterProxy isBytes: bufOop).
	interpreterProxy failed ifTrue: [^ 0].

	bytesWritten := self Serial: portNum
						Port: (self cCoerce: (interpreterProxy firstIndexableField: bufOop) to: 'char *')
						Write: (interpreterProxy stSizeOf: bufOop).

	interpreterProxy pop: 3.  						"pop args and rcvr"
	interpreterProxy pushInteger: bytesWritten.	"push result"
	^ 0! !
